package com.bleujin.lore.addon.security;

import java.util.ArrayList;
import java.util.List;

import com.bleujin.lore.core.common.GenericIterator;
import com.bleujin.lore.core.common.GenericIteratorHelper;

public abstract class IUser {
	private List<IUser> upperTree = new ArrayList<IUser>() ;

	private String userId ;
	public IUser(String userId){
		this.userId = userId ;
		upperTree.add(this) ;
	}

	public GenericIterator<IUser> getUpperTree() {
	    return new GenericIteratorHelper<IUser>(upperTree);
    }

	public void partIn(Group group) {
	    upperTree.add(group) ;
    }

	public void dropOut(Group group) {
		upperTree.remove(group) ;
    }

	public abstract boolean isMember() ;

	public String getUserId() {
	    return userId;
    }

	public boolean equals(Object o){
		if (o instanceof IUser){
			return userId.equals( ((IUser)o).userId ) ;
		}
		return false ;
	}
	
	public int hashCode(){
		return userId.hashCode() ;
	}
}
