package com.bleujin.lore.addon.security;

public class UserAuthority {

	public enum Range {
		INCLUDE_SUB_RESOURCE, ONLY_THIS_RESOURCE
	}
	
	public enum Type {
		GRANT, REVOKE
	}
	
	private IResource resource;
	private IUser user;
	private Authority authority;
	private Range includeSub;
	private Type isGrant;

	public UserAuthority(IResource resource, IUser user, Authority authority, Range includeSub, Type isGrant) {
		this.resource = resource;
		this.user = user;
		this.authority = authority;
		this.includeSub = includeSub;
		this.isGrant = isGrant;
	}

	public Authority getAuthority() {
		return authority;
	}

	public Range getRange() {
		return includeSub;
	}

	public Type getType() {
		return isGrant;
	}

	public IResource getResource() {
		return resource;
	}

	public IUser getUser() {
		return user;
	}

	public int hashCode(){
		return toString().hashCode() ;
	}
	
	public boolean equals(Object o){
		if (o instanceof UserAuthority){
			return toString().equals(((UserAuthority)o).toString()) ;
		} 
		return false ;
	}
	
	public String toString(){
		return resource.toString() + ":" + user.getUserId() + ":" + authority.getKey() + ":" + includeSub + ":" + isGrant;
	}
	
}
