package com.bleujin.lore.core;

import junit.framework.Test;
import junit.framework.TestSuite;

import com.bleujin.lore.core.common.TestGenericIterator;
import com.bleujin.lore.core.dimpl.TestCacheLocal;
import com.bleujin.lore.core.dimpl.TestLock;
import com.bleujin.lore.core.dimpl.TestNode;
import com.bleujin.lore.core.dimpl.TestNodeType;
import com.bleujin.lore.core.dimpl.TestNodeTypePrimary;
import com.bleujin.lore.core.dimpl.TestNodetypeMapping;
import com.bleujin.lore.core.dimpl.TestProperty;
import com.bleujin.lore.core.dimpl.TestPropertyDefinition;
import com.bleujin.lore.core.dimpl.TestRootNode;
import com.bleujin.lore.core.dimpl.TestSequence;
import com.bleujin.lore.core.dimpl.TestShare;
import com.bleujin.lore.core.dimpl.TestValidator;
import com.bleujin.lore.core.dimpl.TestVersion;
import com.bleujin.lore.core.link.TestLink;
import com.bleujin.lore.core.mapping.TestConstraint;
import com.bleujin.lore.core.mapping.TestConstrationReflection;
import com.bleujin.lore.core.migration.TestExporter;
import com.bleujin.lore.core.node.TestINode;
import com.bleujin.lore.core.node.TestOtherSession;
import com.bleujin.lore.core.nodetype.TestNodeTypeId;
import com.bleujin.lore.core.observation.TestObserver;
import com.bleujin.lore.core.search.TestSearchPackage;
import com.bleujin.lore.core.security.TestSecurity;
import com.bleujin.lore.core.util.TestJsonNode;
import com.bleujin.lore.core.value.TestArrayValue;
import com.bleujin.lore.core.value.TestValue;
import com.bleujin.lore.core.workspace.TestNamespace;
import com.bleujin.lore.core.workspace.TestUserSession;
import com.bleujin.lore.core.workspace.TestWorkspace;
import com.bleujin.lore.extend.template.TestTemplate;
import com.bleujin.lore.extend.template.TestVelocity;

public class TestCorePackage {

	public static Test suite() {
		TestSuite suite = new TestSuite(TestCorePackage.class.getPackage().getName());

		// workspace
		suite.addTestSuite(TestWorkspace.class) ;
		suite.addTestSuite(TestShare.class);
		suite.addTestSuite(TestUserSession.class) ; // if It is Transient Mode, this not working..
		suite.addTestSuite(TestOtherSession.class) ;
		suite.addTestSuite(TestNamespace.class) ;
		
		// observer
		suite.addTestSuite(TestObserver.class) ;
		
		// constraint package
		suite.addTestSuite(TestConstraint.class);
		suite.addTestSuite(TestConstrationReflection.class);
		suite.addTestSuite(TestValidator.class);
		suite.addTestSuite(TestValue.class) ;
		suite.addTestSuite(TestArrayValue.class) ;
		suite.addTestSuite(TestNodeTypeId.class) ;

		// core
		suite.addTestSuite(TestNodeType.class);
		suite.addTestSuite(TestNodeTypePrimary.class);
		suite.addTestSuite(TestPropertyDefinition.class);
		suite.addTestSuite(TestNodetypeMapping.class);

		suite.addTestSuite(TestINode.class) ;
		suite.addTestSuite(TestNode.class);
		suite.addTestSuite(TestRootNode.class);
		suite.addTestSuite(TestLink.class);
		suite.addTestSuite(TestLock.class);
		suite.addTestSuite(TestProperty.class);
		suite.addTestSuite(TestVersion.class);
		
		suite.addTestSuite(TestExporter.class) ;
		suite.addTestSuite(TestGenericIterator.class) ;
		
		suite.addTestSuite(TestSequence.class) ;
		suite.addTestSuite(TestCacheLocal.class) ;
		
		//
		suite.addTestSuite(TestJsonNode.class) ;
		
		// acl 
		suite.addTestSuite(TestSecurity.class) ;

		
		// search
		suite.addTest(TestSearchPackage.suite()) ;
		
		// template
		suite.addTestSuite(TestTemplate.class) ;
		suite.addTestSuite(TestVelocity.class) ;

		return suite;
	}
}
