package com.bleujin.lore.core.common;

import java.io.Serializable;

import com.bleujin.framework.db.procedure.IStringObject;
import com.bleujin.framework.util.StringUtil;

// immutable class
public final class IDString implements IStringObject, Serializable{

	public final static IDString EMPTY = new IDString("");
	
	private static final long serialVersionUID = 2435586395632060154L;
	private String id ;
	private IDString(String id){
		this.id = id ;
	}
	
	private static IDString create(String id, int minLength, int maxLength){
		if (id == null) throw new IllegalArgumentException("id is null, smallAlphaNumUnderbar, minLengt:" + minLength + ", maxLength:" + maxLength) ;

		String lowerId = id.toLowerCase() ;
		if (StringUtil.isIdAble(lowerId, minLength, maxLength)) {
			return new IDString(lowerId) ;
		}
		throw new IllegalArgumentException(id + " smallAlphaNumUnderbar, minLengt:" + minLength + ", maxLength:" + maxLength) ;
	}
	
	
	public static IDString shortId(String ntId){
		return create(ntId, 2, 20) ;
	}
	
	public static IDString unknownId(String str){
		return create(str, 1, 100) ;
	}

	
	public static IDString propId(String pdId){
		return create(pdId, 2, 20) ;
	}
	
	public static IDString linkTypeId(String typeId){
		return create(typeId, 4, 20) ;
	}
	
	public static IDString seqId(String seqId){
		return create(seqId, 4, 20) ;
	}
	
	public static IDString prefixId(String prefixId){
		return create(prefixId, 2, 12) ;
	}
	
	
	public String getString(){
		return id ;
	}

	public boolean equals(Object obj){
		if (! (obj instanceof IDString)) return false ;
		
		return getString().equals( ((IDString)obj).getString() ) ;
	}
	
	public int hashCode(){
		return id.hashCode() ;
	}
	
	public String toString(){
		return getString() ;
	}
}
