package com.bleujin.lore.core.common;

import java.util.ArrayList;
import java.util.List;

public class Page<T> {

	public final static Page ALL = new Page(10000, 1, 10) ;
	public final static Page HUNDRED = new Page(100, 1, 10) ;
	public final static Page HUNDRED_ONE = new Page(101, 1, 10) ;
	public static final Page TEN = new Page(10, 1, 10);
	public static final Page TEN_ONE = new Page(11, 1, 10);
	private int listNum ;
	private int pageNo ;
	private int screenCount ;
	
	private Page(int listNum, int pageNo, int screenCount) {
		this.listNum = listNum ;
		this.pageNo = pageNo ;
		this.screenCount = screenCount ;
	}
	
	public final static Page create(int listNum, int pageNo){
		return new Page(listNum, pageNo, 10) ;
	}
	
	public final static Page create(int listNum, int pageNo, int screenCount){
		return new Page(listNum, pageNo, screenCount) ;
	}
	
	public int getListNum(){
		return listNum;
	}
	
	public int getPageNo(){
		return pageNo ;
	}
	
	public int getScreenCount(){
		return screenCount ;
	}
	
	public int getStartLoc(){
		return listNum * (pageNo - 1) ;
	}
	
	public int getEndLoc(){
		return listNum * pageNo ;
	}

	public int getMaxCount(){
		return listNum * screenCount * new Double(Math.ceil(pageNo /10.0)).intValue() + 1;
	}
	
	public List<T> subList(List<T> result) {
		if (result.size() < getStartLoc()) {
			return new ArrayList<T>() ;
		}
	    
		return result.subList(getStartLoc(), Math.min(result.size(), getEndLoc())) ;
    }
	
	public String toString(){
		return "listNum:" + getListNum() + ", pageNo:" + getPageNo() ;
	}

	public Page getNextPage() {
		return create(this.listNum, this.pageNo + 1);
	}

	public Page getPrePage() {
		return create(this.listNum, (this.pageNo == 1) ? 1 : this.pageNo - 1);
	}
	
}
