package com.bleujin.lore.core.dimpl;

import com.bleujin.lore.core.common.GenericIterator;
import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.exception.NamespaceException;
import com.bleujin.lore.core.link.LinkType;
import com.bleujin.lore.core.node.Property.Type;
import com.bleujin.lore.core.nodetype.NodeType;
import com.bleujin.lore.core.nodetype.NodeTypeId;
import com.bleujin.lore.core.nodetype.NewNodeType;
import com.bleujin.lore.core.nodetype.PropertyDefinition;
import com.bleujin.lore.core.persitence.GlobalStore;
import com.bleujin.lore.core.persitence.URI;

public abstract class AbstractGlobalStore extends GlobalStore {

	protected abstract NodeType getNodeType(AbstractGlobalStore globalStore, NodeTypeId ntId) throws NamespaceException, ALRepositoryException ;

	public LinkType createLinkType(String linkTypeName) throws ALRepositoryException {
		return getLinkType(linkTypeName) ;
	}

	public final NodeType getNodeType(String ntName) throws NamespaceException, ALRepositoryException {
		return getNodeType(this, toNodeTypeId(ntName)) ;
	}
	
	protected NewNodeType newNodeType(GlobalStore store, NodeType supertype, String ntId, PropertyDefinition[] definitions) throws ALRepositoryException{
		return NodeTypeTemplateImpl.create(supertype, toNodeTypeId(ntId), definitions) ;
	}
	
	public PropertyDefinitionImpl createPropertyDefinition(String propId, Type type) throws ALRepositoryException {
		return PropertyDefinitionImpl.create(propId, type) ;
	}
	
	
	public NodeTypeId toNodeTypeId(String ntName) throws NamespaceException{
		return NodeTypeIdImpl.create( getNamespace(), ntName) ;
	}

	public abstract void clearStore() throws ALRepositoryException ;
	public abstract void confirm() ;

	protected abstract int addURIAddress(String prefix, String address)  ;
	protected abstract void removeURIAddress(String prefix) ;
	protected abstract boolean existURIAddress(String prefix) throws NamespaceException ;
	protected abstract URI getURIAddress(String prefix) throws NamespaceException;
	protected abstract GenericIterator<URI> listURIAddress() ;
}
