package com.bleujin.lore.core.dimpl;

import com.bleujin.lore.core.common.GenericIterator;
import com.bleujin.lore.core.common.Page;
import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.exception.SearchException;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.persitence.ILocalStore;
import com.bleujin.lore.core.search.indexer.NodeIndexer;
import com.bleujin.lore.core.search.searcher.NodeSearcher;

public abstract class AbstractLocalStore implements ILocalStore{

	private NodeIndexer indexer ;

	public AbstractLocalStore(NodeIndexer indexer) {
		this.indexer = indexer ;
	}

	public NodeIndexer getIndexer() {
	    return indexer;
    }
	
	public NodeSearcher getSearcher(UserSession session, Node startNode) {
	    return new NodeSearcher(session, startNode, indexer.getDirectory());
    }

	public GenericIterator<Node> searchNode(UserSession session, Node startNode, String searchText, Page page) throws SearchException, ALRepositoryException {
	    return getSearcher(session, startNode).search(searchText, page.getMaxCount()).toNodeIterator(page);
    }
	

}
