package com.bleujin.lore.core.dimpl;

import java.util.Queue;
import java.util.concurrent.ConcurrentLinkedQueue;

import com.bleujin.lore.core.common.IDString;

public class CacheSequence extends AbstractSequence{
	
	private DatabaseSequence inner ;
	private Queue<Long> cachedVal = new ConcurrentLinkedQueue<Long>() ;
	private int prepareNum = 20;
	
	public CacheSequence(DatabaseSequence inner){
		this(inner, 20) ;
	}
	
	public CacheSequence(DatabaseSequence inner, int parepareNum){
		this.inner = inner ;
		this.prepareNum = parepareNum ;
	}
	
	public synchronized long currVal(IDString seqId) {
		if (cachedVal.isEmpty()){
			cachePrepareNum(seqId) ;
			return currVal(seqId) ;
		} else {
			return cachedVal.peek() -1 ;
		}
	}

	public synchronized long nextVal(IDString seqId) {
		if (cachedVal.isEmpty()){
			cachePrepareNum(seqId);
			return nextVal(seqId) ;
		} else {
			return cachedVal.poll() ;
		}
	}

	private void cachePrepareNum(IDString seqId) {
		long value = inner.prepare(seqId, prepareNum) ;
		for (int i = 20; i > 0; i--) {
			cachedVal.add(value-i+1) ;
		}
	}

	public synchronized void reset(IDString seqId) {
		inner.reset(seqId) ;
		cachedVal.clear() ;
	}

}
