package com.bleujin.lore.core.dimpl;

import java.util.List;

import org.apache.ecs.xml.XML;

import com.bleujin.lore.core.common.GenericIterator;
import com.bleujin.lore.core.common.GenericIteratorHelper;
import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.node.NodeVersion;
import com.bleujin.lore.core.node.VersionHistory;


public class DatabaseVersionHistory implements VersionHistory {

	private List<NodeVersion> versions;
	private Node currentNode;

	public DatabaseVersionHistory(List<NodeVersion> versions, Node currentNode) {
		this.versions = versions;
		this.currentNode = currentNode;
	}

	public GenericIterator<NodeVersion> getAllVersions() {
		return new GenericIteratorHelper<NodeVersion>(versions);
	}

	public Node getRecentNode() {
		return currentNode ;
		// return versions.get(versions.size()-1);
	}

	public NodeVersion getVersion(int index) {
		return versions.get(index);
	}

	public XML toXML() throws ALRepositoryException {
		XML result = new XML(VERSIONS);

		GenericIterator<NodeVersion> versions = getAllVersions();
		while (versions.hasNext()) {
			result.addElement(versions.next().toXML());
		}

		return result;
	}

}
