package com.bleujin.lore.core.dimpl;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import com.bleujin.lore.core.link.LinkType;
import com.bleujin.lore.core.nodetype.NodeType;
import com.bleujin.lore.core.persitence.Sequence;
import com.bleujin.lore.core.persitence.URI;
import com.bleujin.lore.extend.template.Template;
import com.bleujin.lore.extend.template.TemplateId;

public class GlobalFileStore {

	
	private Map<TemplateId, Template> templates = new HashMap<TemplateId, Template>() ;
	private Map<String, TemplateId> templateBind = new HashMap<String, TemplateId>() ;
	private Map<String, URI> namespaceStore = new HashMap<String, URI>() ;
	private Map<String, ShareInfo> shares = new HashMap<String, ShareInfo>() ;
	private Map<String, LinkType> storeLinkType = new HashMap<String, LinkType>(); // name, linkType
	//private ByteArrayOutputStream store = new ByteArrayOutputStream();
	private Set<NodeType> nodetypes = new HashSet<NodeType>() ;
	private Sequence sequence = TransientSequence.getInstance() ;
	
	private File file ;
	private GlobalFileStore(File file){
		this.file = file ;
	}
	
	static GlobalFileStore create(String fileName) throws IOException, ClassNotFoundException{
		GlobalFileStore gs = new GlobalFileStore(new File(fileName)) ;
		
		File gsfile = gs.file;
		
		if (! gsfile.getParentFile().exists()) gsfile.getParentFile().mkdirs() ;
		if (! gsfile.exists()) gsfile.createNewFile() ;
		
		if (gsfile.length() == 0){
			gs.templates =  new HashMap<TemplateId, Template>() ;
			gs.templateBind = new HashMap<String, TemplateId>() ;
			gs.namespaceStore = new HashMap<String, URI>() ;
			gs.shares = new HashMap<String, ShareInfo>() ;
			gs.storeLinkType = new HashMap<String, LinkType>(); // name, linkType
			gs.nodetypes = new HashSet<NodeType>();
			gs.sequence = TransientSequence.getInstance() ;
		}else {
			ObjectInputStream input = new ObjectInputStream(new FileInputStream(gsfile)) ;
			gs.templates = (Map<TemplateId, Template>)input.readObject() ;
			gs.templateBind = (Map<String, TemplateId>)input.readObject() ;
			gs.namespaceStore = (Map<String, URI>)input.readObject() ;
			gs.shares = (Map<String, ShareInfo>)input.readObject() ;
			gs.storeLinkType = (Map<String, LinkType>)input.readObject() ;
			gs.nodetypes = (Set<NodeType>)input.readObject();
			gs.sequence = (Sequence)input.readObject() ;
		}
		
		return gs ;
	}
	
	public void write(){
		try {
			FileOutputStream fo = new FileOutputStream(file) ;
			ObjectOutputStream output = new ObjectOutputStream(fo) ;
			output.writeObject(templates) ;
			output.writeObject(templateBind) ;
			output.writeObject(namespaceStore) ;
			output.writeObject(shares) ;
			output.writeObject(storeLinkType) ;
			output.writeObject(nodetypes) ;
			output.writeObject(sequence) ;
			output.close() ;
		} catch(IOException ex){
			ex.printStackTrace() ;
		}
	}
}
