package com.bleujin.lore.core.dimpl;

import com.bleujin.lore.core.common.IDString;
import com.bleujin.lore.core.link.LinkType;

public class LinkTypeImpl implements LinkType{
 
	private static final long serialVersionUID = -7680425450574420343L;

	public enum Direction {FROM_SELF, TO_SELF, ALL}
	
	public final static LinkType CHILD = new LinkTypeImpl(IDString.linkTypeId("_child"));
	public final static LinkType MEMBER = new LinkTypeImpl(IDString.linkTypeId("_member"));
	public final static LinkType AGREE = new LinkTypeImpl(IDString.linkTypeId("_agree"));
	public final static LinkType DISAGREE = new LinkTypeImpl(IDString.linkTypeId("_disagree"));
	public final static LinkType REFERENCE = new LinkTypeImpl(IDString.linkTypeId("_reference"));
	public final static LinkType PATH = new LinkTypeImpl(IDString.linkTypeId("_path"));
	
	private final IDString type;

	private LinkTypeImpl(IDString type) {
		this.type = type;
	}
	
	public static LinkType load(String typeName){
		return new LinkTypeImpl(IDString.linkTypeId(typeName)) ;
	}

	public String getString() {
		return type.getString() ;
	}
	
	public String toString(){
		return getString() ;
	}

	public boolean equals(Object other){
		if (! (other instanceof LinkType)) return false ;
		
		return getString().equals(((LinkType)other).getString()) ;
	}

	public int hashCode(){
		return getString().hashCode() ;
	}
}
