package com.bleujin.lore.core.dimpl;

import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.node.Lock;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.observation.UserBean;
import com.bleujin.lore.core.workspace.LockManager;

public class LockImpl implements Lock{

	private LockManager manager ;
	private UserBean owner;
	private Node target;
	private boolean isDeep;
	private boolean isSessionScope;

	private LockImpl(LockManager manager, Node target, boolean isDeep) {
		this.manager = manager ;
		this.owner = target.getSession().getUserBean();
		this.target = target;
		this.isDeep = isDeep;
		this.isSessionScope = true;
	}

	public final static Lock create(LockManager manager, Node target, boolean isDeep){
		return new LockImpl(manager, target, isDeep) ;
	}
	
	public Node getNode() {
		return target;
	}

	public boolean isDeep() {
		return isDeep;
	}

	public void unlock() throws ALRepositoryException, InterruptedException {
		manager.release(this);
	}

	public String toString() {
		return "lock:" + target.toString() + ", " + isDeep;
	}

	public boolean isOwner(UserBean user) {
		return owner.getUserId().equals(user.getUserId());
	}
}
