package com.bleujin.lore.core.dimpl;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import com.bleujin.lore.core.bean.Register;
import com.bleujin.lore.core.common.GenericIterator;
import com.bleujin.lore.core.common.GenericIteratorHelper;
import com.bleujin.lore.core.common.IConstant;
import com.bleujin.lore.core.common.Page;
import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.node.NodeName;
import com.bleujin.lore.core.nodetype.NodeType;
import com.bleujin.lore.core.observation.Event.Mode;
import com.bleujin.lore.core.persitence.NodeBean;

public class NodeMemoryImpl extends NodeImpl implements IConstant {

    private static final long serialVersionUID = -7513782534350067084L;
 
	public final static int UNKNOWN_VERSION = -1 ;
	//private List<Link> links;
	private NodeMemoryImpl(UserSession session, String parentId, NodeBean bean, int versionNum, Mode mode){
		super(session, mode, parentId, bean, versionNum, true);
		//this.links = new ArrayList<Link>();
	}

	protected NodeMemoryImpl(UserSession session, String parentId, Node before) throws ALRepositoryException {
		this(session, parentId, ((AbstractNode)before).getBean(), before.getVersionNum(), Mode.CREATED) ;
		// 왜? 링크는 복사를 안하는거지??
		// this.links = before.getLinks(Page.ALL).toList() ;
	}


	static NodeMemoryImpl create(UserSession session, Node parent, NodeType ntype, NodeName name, String explain) {
		Register regInfo = new Register(session.getUserId()) ;
		String workspaceName = session.getWorkspace().getName() ;
		return new NodeMemoryImpl(session, parent.getIdentifier(), NodeBeanImpl.create(ntype, name, explain, regInfo, workspaceName), INIT_VERSION, Mode.CREATED);
	}


	public Node newClone(UserSession session) {
		NodeMemoryImpl clone = new NodeMemoryImpl(session, getParentId(), this.getBean().newClone(), getVersionNum(), getMode()) ;
		this.copyLink(clone) ;
		this.copyProperty(clone) ;
		return clone ;
		
		// return super.newClone(session) ;
	}
	
	
	public GenericIterator<Node> getDescentNode(int maxDepth) throws ALRepositoryException {
		List<Node> result = new ArrayList<Node>();
		retrieveChildNodeTo(this, result, maxDepth);

		return new GenericIteratorHelper<Node>(Collections.unmodifiableCollection(result));
	}

	
	private void retrieveChildNodeTo(Node parent, List target, int maxDepth) throws ALRepositoryException {
		if (maxDepth <= 0)
			return;
		
		GenericIterator<Node> iter = parent.getChildNode(Page.ALL);
		
		for (Node child : iter) {
			if (child == null) continue ; // not saved node
			if (child.getMode().isDeleted()) continue ;
			
			target.add(child);
			retrieveChildNodeTo(child, target, --maxDepth);
		}
	}

//	public void move(Node newParent) throws ALRepositoryException {
//		Node oldParent = getParent();
//		
//		if (oldParent instanceof NodeMemoryImpl) {
//			((NodeMemoryImpl) oldParent).removeChild(this);
//		}
//
//		super.move(newParent) ;
//		// ..
//		// TODO remove before parent link...
//	}	
	

//	@Override
//	public void addLink(Node target, LinkType linkType, Position position) throws ALRepositoryException {
//		Link link = getSession().createLink(this, target, linkType, position);
//		if (Position.AFTER.equals(position)) {
//			links.add(link);
//		} else {
//			links.add(0, link);
//		}
//	}

	
	// TransientLocalStore.save 때문에 어쩔수 없이 만듬

	// internal path...
//	List<Link> getIternalLinks() throws ALRepositoryException {
//		List<Link> oldLink = new ArrayList<Link>();
//		Debug.debug(links.size());
//		for (Link link : links) {
//			// if (getSession().getNode(link.getToId()).getMode().isCreated()) {
//			// Debug.debug(getSession().getNode(link.getToId()));
//			// continue ;
//			// }
//			oldLink.add(link);
//		}
//		return oldLink;
//	}

//	private void removeChild(Node child) throws ALRepositoryException {
//		for (Link link : links) {
//			if (LinkTypeImpl.CHILD.equals(link.getType()) && link.getToId().equals(child.getIdentifier())) {
//				links.remove(link);
//				return;
//			}
//		}
//	}	
	
}
