package com.bleujin.lore.core.dimpl;

import com.bleujin.lore.core.common.GenericIterator;
import com.bleujin.lore.core.common.IDString;
import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.node.Property;

public class NodePrimaryImpl extends NodeImpl{


	private final NodeImpl base ;
	private final Property primaryProperty ;
	
	NodePrimaryImpl(NodeImpl node, Property propertyProperty) throws ALRepositoryException{
		super(node.getSession(), node.getMode(), node.getParent().getIdentifier(), node.getBean(), node.getVersionNum(), false) ;
		this.base = node ;
		this.primaryProperty = propertyProperty ;
	}
	
	public Property getProperty(IDString propId) throws ALRepositoryException{
		if (propId.equals(primaryProperty.getId())) {
			return primaryProperty ;
		} else {
			return base.getProperty(propId) ;
		}
	}
	
	public GenericIterator<Node> getDescentNode(int maxDepth) throws ALRepositoryException {
		return base.getDescentNode(maxDepth);
	}
	
}
