package com.bleujin.lore.core.dimpl;

import com.bleujin.lore.core.common.IDString;
import com.bleujin.lore.core.node.Property;
import com.bleujin.lore.core.nodetype.PropertyDefinition;

public class PropertyDefinitionImpl implements PropertyDefinition{
    private static final long serialVersionUID = -7949744288988767563L;
	private IDString propId;
	private Property.Type requiredType;

	private PropertyDefinitionImpl(IDString propId, Property.Type requiredType) {
		this.propId = propId ;
		this.requiredType = requiredType;
	}

	final static PropertyDefinitionImpl create(String propId, Property.Type requiredType) {
		return create(IDString.propId(propId), requiredType) ;
	}

	final static PropertyDefinitionImpl create(IDString propId, Property.Type requiredType) {
		return new PropertyDefinitionImpl(propId, requiredType);
	}

	public IDString getId() {
		return propId;
	}
	
	public String getName(){
		return getId().getString() ;
	}

	public boolean isSameProperty(IDString _propId) {
		return getId().equals(_propId);
	}

	public Property.Type requiredType() {
		return this.requiredType;
	}

	public String toString(){
		return propId + ":" + requiredType ;
	}

}
