package com.bleujin.lore.core.dimpl;

import com.bleujin.framework.db.Row;
import com.bleujin.framework.util.DateUtil;
import com.bleujin.lore.core.bean.Register;
import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.nodetype.NodeTypeId;

public final class RowToNodeBean {

	private NodeTypeId nodeTypeId ;
	private String name ;
	private String explain ;
	private String uuid ;
	private String parentId ;
	private Register register ;
	private int viewCount ;
	private String workspaceName ;
	private RowToNodeBean(UserSession session, Row row) throws ALRepositoryException{
		this.nodeTypeId = NodeTypeIdImpl.create(session.getNodeTypeManager().getNamespace(), row.getString("ntId")) ;
		this.name = row.getString("name") ;
		this.explain = row.getString("explain") ;
		this.uuid = row.getString("uuid") ;
		this.parentId = row.getString("parentId") ;
		this.register = new Register(row.getString("regUserId"), DateUtil.stringToCalendar(row.getString("regDate"))) ;
		this.viewCount = row.getInt("viewCount") ;
		this.workspaceName = row.getString("workspaceName") ;
		// this.workspaceName = null ;
	}
	
	static RowToNodeBean create(UserSession session, Row row) throws ALRepositoryException{
		return new RowToNodeBean(session, row) ;
	}
	
	public String getName() {
		return this.name ;
	}

	public String getExplain(){
		return this.explain ;
	}
	
	public NodeTypeId getNodeTypeId() {
		return nodeTypeId ;
	}

	public String getParentNodeId() {
		return parentId ;
	}
	
	public String getUUID(){
		return uuid ;
	}

	public int getViewCount() {
		return viewCount ;
	}

	public Register getRegister() {
		return register ;
	}

	public String getWorkspaceName() {
		return workspaceName;
	}
}
