package com.bleujin.lore.core.dimpl;

import java.io.Serializable;

public final class ShareInfo implements Serializable {

	private static final long serialVersionUID = 3258348175734080972L;
	private String shareName ;
	private String workspaceName ;
	private String nodePath ;
	private boolean enableWrite ;
	
	private ShareInfo(String shareName, String workspaceName, String nodePath, boolean enableWrite) {
		this.shareName = shareName ;
		this.workspaceName= workspaceName ;
		this.nodePath = nodePath ;
		this.enableWrite = enableWrite ;
	}

	static ShareInfo create(String shareName, String workspaceName, String nodePath, boolean enableWrite) {
		return new ShareInfo(shareName, workspaceName, nodePath, enableWrite) ;
	}

	public String getWorkspaceName(){
		return workspaceName ;
	}

	public String getNodePath() {
		return this.nodePath;
	}

	public boolean isEnableWrite() {
		return enableWrite;
	}
	
	public String getShareName() {
		return shareName ;
	}

}
