package com.bleujin.lore.core.dimpl;

import com.bleujin.lore.core.TestCaseParent;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.value.Value;
import com.bleujin.lore.core.workspace.Credential;

public class TestCacheLocal extends TestCaseParent{

	public void testDefault() throws Exception {
		Node newNode = saveNode(getRobotType(), "abc") ;
		String explain = "explain";
		newNode.setProperty(explain, Value.stringValue("abcd")) ;
		session.save() ;
		
		UserSession otherSession = anotherLore.login(Credential.ALL_OK) ;
		Node loadNode = otherSession.getNode("/abc") ;
		assertEquals("abcd", loadNode.getString(explain)) ;
		
		newNode.setProperty(explain, "1234") ;
		session.save() ;
		
		loadNode = otherSession.getNode("/abc") ;
		assertEquals("1234", loadNode.getString(explain)) ;
	}
	
	
	public void testPath() throws Exception {
		Node newNode = saveNode(getRobotType(), "abc") ;
		String explain = "explain";
		newNode.setProperty(explain, Value.stringValue("abcd")) ;
		
		Node childNode = createNodeSave(newNode, getRobotType(), "child") ;
		childNode.setProperty(explain, Value.stringValue("abcd")) ;
		
		session.save() ;
		
		UserSession otherSession = anotherLore.login(Credential.ALL_OK) ;
		Node loadNode = otherSession.getNode("/abc/child") ;
		assertEquals("abcd", loadNode.getString(explain)) ;
		
		childNode.setProperty(explain, "1234") ;
		session.save() ;
		loadNode = otherSession.getNode("/abc/child") ;
		assertEquals("1234", loadNode.getString(explain)) ;
		
		session.getNode(childNode.getUUIDString()) ;
		session.getNode(childNode.getUUIDString()) ;
		session.getNode(childNode.getUUIDString()) ;
		session.getNode("/abc/child") ;
		session.getNode("/abc/child") ;
		session.getNode(childNode.getUUIDString()) ;
		
		otherSession.getNode("/abc/child") ;
		otherSession.getNode(childNode.getUUIDString()) ;
		otherSession.getNode("/abc/child") ;
		
	}
}
