package com.bleujin.lore.core.dimpl;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import com.bleujin.lore.core.TestCaseParent;
import com.bleujin.lore.core.node.Node;

public class TestFileObjectStore extends TestCaseParent{

	private String fileName = "/temp/t123.dat";
	private LocalFileStore fos = null ;
	public void setUp() throws Exception {
		super.setUp() ;
		fos = LocalFileStore.create(fileName) ;
	}
	
	public void testWrite() throws Exception {
		
		Node n1 = saveNode(getRobotType(), "1") ;
		Node n2 = saveNode(getRobotType(), "2") ;
		Node n3 = saveNode(getRobotType(), "3") ;
		
		List<Node> nodes = new ArrayList<Node>(Arrays.asList(new Node[]{n1, n2, n3}));
		
		fos.writeNode(nodes) ;
	}
	
	public void testRead() throws Exception {
		List<Node> nodes = (List<Node>)fos.readNode() ;
		assertEquals("1", nodes.get(0).getName()) ;
		assertEquals("2", nodes.get(1).getName()) ;
		assertEquals("3", nodes.get(2).getName()) ;
	}
	
	
	
}
