package com.bleujin.lore.core.dimpl;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;

import com.bleujin.lore.core.TestCaseParent;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.nodetype.NodeType;
import com.bleujin.lore.core.persitence.GlobalStore;
import com.bleujin.lore.core.persitence.Sequence;
import com.bleujin.lore.extend.template.Template;
import com.bleujin.lore.extend.template.TemplateId;
import com.bleujin.lore.extend.template.TemplateImpl;

public class TestGlobalFileStore extends TestCaseParent{

//	private Map<TemplateId, Template> templates = new HashMap<TemplateId, Template>() ;
//	private Map<String, TemplateId> templateBind = new HashMap<String, TemplateId>() ;
//	private Map<String, URI> namespaceStore = new HashMap<String, URI>() ;
//	private Map<String, ShareInfo> shares = new HashMap<String, ShareInfo>() ;
//	private Map<String, LinkType> storeLinkType = new HashMap<String, LinkType>(); // name, linkType
//	//private ByteArrayOutputStream store = new ByteArrayOutputStream();
//	private Set<NodeType> nodetypes = new HashSet<NodeType>() ;
//	private Sequence sequence = TransientSequence.getInstance() ;

	private File file = new File("c:/temp/1234.dat");
	public void testSave() throws Exception {
		
		
		GlobalStore gs = session.getWorkspace().getGlobalStore() ;
		NodeType robot = getRobotType() ; // register nodetype
		Node node = saveNode(robot, "robot") ;
		
		Template tpl = TemplateImpl.create(session, "abcd", "$node") ;
		TemplateId tplId = TemplateId.createId("abcd");
		gs.saveTemplate(tplId, tpl) ;
		gs.bindTemplate(node, tplId) ;
		gs.getNamespace().add("test", "com.bleujin.test") ;
		workspace.shareNode("share", "/robot", false) ;
		gs.createLinkType("abcd") ;
		Sequence seq = gs.getSequence() ;
		seq.nextVal("abcd") ;
		
		if (gs instanceof TransientGlobalStore){
			FileOutputStream fo = new FileOutputStream(file) ;
			ObjectOutputStream oos = new ObjectOutputStream(fo);
			
			oos.writeObject(gs) ;
		}
	}
	
	
	public void testRead() throws Exception {
		testSave() ;
		
		ObjectInputStream ois = new ObjectInputStream(new FileInputStream(file)) ;
		GlobalStore gs = (GlobalStore)ois.readObject() ;
		if (gs instanceof TransientGlobalStore){
			TransientGlobalStore tgs = (TransientGlobalStore)gs ;
			
			assertEquals(true, tgs.getNodeType("robot") != null) ;
			assertEquals(true, tgs.getTemplate(session, TemplateId.createId("abcd"))  != null);
			assertEquals(true, tgs.getNamespace().isContainPrefix("test")) ;
			assertEquals(true, tgs.getSequence().currVal("abcd") >= 1) ;
			assertEquals(true, tgs.getLinkType("abcd") != null) ;
			
			

		}
		
		
	}
	
	
}
