package com.bleujin.lore.core.dimpl;

import com.bleujin.lore.core.TestCaseParent;
import com.bleujin.lore.core.nodetype.NodeType;
import com.bleujin.lore.core.nodetype.NewNodeType;
import com.bleujin.lore.core.nodetype.PropertyDefinition;

public class TestNodeTypePrimary extends TestCaseParent{
	
	public void testInterface() throws Exception {
		NewNodeType robotTypeTemplate = getRobotTypeTemplate() ;
		PropertyDefinition pd = robotTypeTemplate.getMappedDefinition("explain").getPropertyDefinition() ;
		
		assertEquals(null, robotTypeTemplate.getPrimaryPropertyId()) ;

		robotTypeTemplate.setPrimary(pd) ;
		assertEquals("explain", robotTypeTemplate.getPrimaryPropertyId()) ;
	}
	
	public void testUpdate() throws Exception {
		NodeType robotType = getRobotType() ;
		assertEquals(null, robotType.getPrimaryPropertyId());
		
		NewNodeType updateType = robotType.updateFor() ;
		updateType.setPrimary("explain") ;
		
		
		NodeType savedType = session.getNodeTypeManager().register(updateType, true) ;
		assertEquals("explain", savedType.getPrimaryPropertyId()) ;
		
		NodeType loadType = ntManager.getNodeType("robot") ;
		assertEquals("explain", loadType.getPrimaryPropertyId()) ;
	}

}
