package com.bleujin.lore.core.dimpl;

import com.bleujin.lore.core.TestCaseParent;
import com.bleujin.lore.core.common.GenericIterator;
import com.bleujin.lore.core.mapping.CurrentDateValue;
import com.bleujin.lore.core.mapping.StringDefaultValue;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.nodetype.MappedDefinition;
import com.bleujin.lore.core.nodetype.NodeType;
import com.bleujin.lore.core.nodetype.NewNodeType;
import com.bleujin.lore.core.nodetype.PropertyDefinition;

public class TestNodetypeMapping extends TestCaseParent{
	
	public void testConstraint() throws Exception {
		NodeType robot = getRobotType() ;
		GenericIterator<MappedDefinition> mds = robot.getMappedDefinitions() ;
		int i = 0 ;
		for (MappedDefinition md : mds) {
			if (md.getConstraint() != null) i++ ;
		}

		assertEquals(1, i) ;

		NodeType newtype = registerNodeType(objectType, "newtype", new PropertyDefinition[0]) ;
		mds = newtype.getMappedDefinitions() ;
		i = 0 ;
		for (MappedDefinition md : mds) {
			if (md.getConstraint() != null) i++ ;
		}
		assertEquals(0, i) ;
		
	}
	
	public void testDefaultValue() throws Exception {
		String explain = "explain";
		String hi = "Hi~";
		NewNodeType robotTemplate = getRobotTypeTemplate() ;
		robotTemplate.setDefaultValue(explain, new StringDefaultValue(hi)) ;
		NodeType robot = registerNodeType(robotTemplate) ; 
		
		Node node = saveNode(robot, "M949") ;
		assertEquals(hi, node.getProperty(explain).getString()) ;
	}
	
	public void testViolateDefaultType() throws Exception {
		NewNodeType robotTemplate = getRobotTypeTemplate() ;
		robotTemplate.setDefaultValue("explain", new CurrentDateValue()) ;
		
		NodeType robot = registerNodeType(robotTemplate) ;
		
		Node r = saveNode(robot, "abc") ;
		r.save() ;

	}

}
