package com.bleujin.lore.core.dimpl;

import com.bleujin.lore.core.TestCaseParent;
import com.bleujin.lore.core.exception.NoSuchPropertyDefinitionException;
import com.bleujin.lore.core.node.Node;

public class TestRootNode extends TestCaseParent{

	public void testRoot() throws Exception {
		Node testFirstNode = createTestNode() ;
		Node rootNode = testFirstNode.getParent() ;
		assertEquals("", rootNode.getPath()) ;
		
		Node node = session.getNode("") ;
		assertEquals("", node.getPath()) ;
	}
	
	
	public void testGetProperties() throws Exception {
		Node rootNode = session.getRootNode();
		assertEquals(0, rootNode.getProperties().size()) ;
		
		try {
			rootNode.getProperty("name") ;
			fail() ;
		} catch(NoSuchPropertyDefinitionException ignore){
		}
	}
	
	public void testLink() throws Exception {
		Node node = session.getNode("") ;
		assertEquals(0, node.getChildNode().size());
	}
}
