package com.bleujin.lore.core.dimpl;

import com.bleujin.framework.db.DBController;
import com.bleujin.lore.core.TestCaseParent;
import com.bleujin.lore.core.common.IDString;
import com.bleujin.lore.core.persitence.Sequence;

public class TestSequence extends TestCaseParent{

	public void testSeq() throws Exception {
	    Sequence seq = session.getSequence() ;
	    
	    IDString seqId = IDString.seqId("seq_name") ;
	    seq.reset(seqId) ;
		long i = seq.nextVal(seqId) ;
		assertEquals(1, i) ;
		
		assertEquals(1L, seq.currVal(seqId)) ;
		assertEquals(2L, seq.nextVal(seqId)) ;
		assertEquals(3L, seq.nextVal(seqId)) ;
		
    }
	
	public void testCacheSequence() throws Exception {
		DBController dcInner = DBController.getTestInstance();
		if (! dcInner.getDBManager().isCreated()) return  ;
		DatabaseSequence dseq = new DatabaseSequence(session.getNodeTypeManager().getNamespace(), dcInner) ;
		
		Sequence seq = new CacheSequence(dseq) ;
		
	    IDString seqId = IDString.seqId("seq_name") ;
	    seq.reset(seqId) ;
		
		long i = seq.nextVal(seqId) ;
		assertEquals(1, i) ;

		assertEquals(1L, seq.currVal(seqId)) ;
		assertEquals(2L, seq.nextVal(seqId)) ;
		assertEquals(3L, seq.nextVal(seqId)) ;
		
	    seq.reset(seqId) ;
		assertEquals(0, seq.currVal(seqId)) ;
		for (int j = 1; j < 111; j++) {
			assertEquals(1L *j, seq.nextVal(seqId)) ;
			assertEquals(1L *j, seq.currVal(seqId)) ;
		}
	}
	
}
