package com.bleujin.lore.core.dimpl;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import com.bleujin.lore.core.common.IDString;

public class TransientSequence extends AbstractSequence implements Serializable{

	private static final long serialVersionUID = -715574504582844190L;
	private Map<IDString, Long> seq = new HashMap<IDString, Long>() ;
	private static TransientSequence SELF = new TransientSequence() ; 
	
	public static TransientSequence getInstance(){
		return SELF ;
	}
	
	public synchronized long currVal(IDString seqId) {
		if (seq.containsKey(seqId)) {
			return seq.get(seqId).longValue() ;
		} else {
			reset(seqId) ;
			return currVal(seqId) ;
		}
	}

	public synchronized long nextVal(IDString seqId) {
		long nextVal = currVal(seqId) + 1 ;
		seq.put(seqId, nextVal) ;
		return nextVal ;
	}

	public synchronized void reset(IDString seqId) {
		seq.put(seqId, 0L) ;
	}

}
