package com.bleujin.lore.core.dimpl.carrier;

import java.util.List;
import java.util.Map;

import com.bleujin.framework.db.DBController;
import com.bleujin.framework.db.NRows;
import com.bleujin.framework.db.Rows;
import com.bleujin.framework.db.bean.handlers.MapListHandler;
import com.bleujin.framework.db.procedure.IQueryable;
import com.bleujin.framework.db.procedure.IUserCommand;
import com.bleujin.framework.db.procedure.IUserCommandBatch;
import com.bleujin.framework.db.procedure.IUserProcedure;
import com.bleujin.framework.db.procedure.IUserProcedureBatch;
import com.bleujin.lore.common.Debug;

public abstract class Carrier implements CarrierConstant {

	private DBController dc ;
	public Carrier(DBController dc){
		this.dc = dc ;
	}
	
	protected int execUpdate(IQueryable query){
		return dc.execUpdate(query) ;
	}
	
	protected Rows execQuery(IQueryable query){
		return dc.execQuery(query) ;
	}
	
	protected NRows execNQuery(IQueryable query) {
		return new NRows(execQuery(query), new RuntimeException()) ;
	}
	
	protected Map[] toMapArray(IQueryable query){
		List<Map> result =(List<Map>)(dc.getObjectWrapper(query, new MapListHandler()).getObject()) ;
		
		return (Map[])result.toArray(new Map[0]) ;
	}
	
	protected IUserProcedure createUserProcedure(String procName){
		return dc.createUserProcedure(procName) ;
	}

	protected IUserProcedureBatch createUserProcedureBatch(String procName){
		return dc.createUserProcedureBatch(procName) ;
	}


	protected IUserCommand createUserCommand(String procName){
		return dc.createUserCommand(procName) ;
	}

	protected IUserCommandBatch createUserCommandBatch(String procName){
		return dc.createUserCommandBatch(procName) ;
	}

	protected void println(Object obj) {
		Debug.debug(this, obj) ;
	}

}
