package com.bleujin.lore.core.dimpl.carrier;

import com.bleujin.framework.db.DBController;
import com.bleujin.framework.db.NRows;
import com.bleujin.framework.db.procedure.IUserProcedure;
import com.bleujin.lore.core.common.Page;
import com.bleujin.lore.core.link.LinkType;

public class LinkCarrier extends Carrier{

	public LinkCarrier(DBController dc) {
	    super(dc);
    }

	public int create(String fromUUID, String toUUID, String linkType, String position) {
		IUserProcedure upt = createUserProcedure("link@createWith(?,?,?,?)") ;
		upt.addParam(0, fromUUID) ;
		upt.addParam(1, toUUID) ;
		upt.addParam(2, linkType) ;  
		upt.addParam(3, position) ;
		return execUpdate(upt) ;
    }

	public NRows listBy(String uuid, Page page) {
		IUserProcedure upt = createUserProcedure("link@listBy(?,?,?,?)") ;
		upt.addParam(uuid).addParam(page.getListNum()).addParam(page.getPageNo()).addParam(page.getScreenCount()) ;
		
	    return execNQuery(upt);
    }

	public NRows listBy(String uuid, LinkType linktype, Page page) {
		IUserProcedure upt = createUserProcedure("link@listBy2(?,?,?,?,?)") ;
		upt.addParam(uuid).addParam(linktype).addParam(page.getListNum()).addParam(page.getPageNo()).addParam(page.getScreenCount()) ;
		
	    return execNQuery(upt);
    }


	public NRows listNodeBy(String uuid, LinkType linkType, Page page) {
		IUserProcedure upt = createUserProcedure("link@listNodeBy(?,?,?,?,?)");
		upt.addParam(uuid).addParam(linkType).addParam(page.getListNum()).addParam(page.getPageNo()).addParam(page.getScreenCount());

		return execNQuery(upt);
	}	
}
