package com.bleujin.lore.core.dimpl.carrier;

import com.bleujin.framework.db.DBController;
import com.bleujin.framework.db.NRows;
import com.bleujin.framework.db.procedure.IUserProcedure;
import com.bleujin.lore.core.common.IDString;
import com.bleujin.lore.core.nodetype.NodeTypeId;

public class MappingCarrier extends Carrier {
	
	public MappingCarrier(DBController dc) {
		super(dc);
	}

	public NRows listBy(NodeTypeId ntId) {
		IUserProcedure upt = createUserProcedure("type_mapping@listBy(?)") ;
		upt.addParam(ntId) ;
		
		return execNQuery(upt) ;
		
	}
	public int setConstraintWith(NodeTypeId ntId, IDString pdId, String expression) {
		IUserProcedure upt = createUserProcedure("type_mapping@setConstraintWith(?,?,?)") ;
		upt.addParam(ntId).addParam(pdId).addParam(expression) ;
		
		return execUpdate(upt) ;
		
	}
	public int removeConstraintWith(NodeTypeId ntId, IDString pdId) {
		IUserProcedure upt = createUserProcedure("type_mapping@removeConstraintWith(?,?)") ;
		upt.addParam(ntId).addParam(pdId) ;
		
		return execUpdate(upt) ;
		
	}

	public int setDefaultValueWith(NodeTypeId ntId, IDString pdId, String expression) {
		IUserProcedure upt = createUserProcedure("type_mapping@setDefaultWith(?,?,?)") ;
		upt.addParam(ntId).addParam(pdId.getString()).addParam(expression) ;
		
		return execUpdate(upt) ;
	}
}
