package com.bleujin.lore.core.dimpl.carrier;

import com.bleujin.framework.db.DBController;
import com.bleujin.framework.db.NRows;
import com.bleujin.framework.db.procedure.IUserProcedure;

public class NamespaceCarrier extends Carrier{

	public NamespaceCarrier(DBController dc) {
		super(dc);
	}

	public int createWith(String prefix, String address) {
		IUserProcedure upt = createUserProcedure("nodetype@createNSWith(?,?)") ;
		return execUpdate(upt.addParam(prefix).addParam(address));
	}

	public int removeWith(String prefix) {
		IUserProcedure upt = createUserProcedure("nodetype@removeNSWith(?)") ;
		return execUpdate(upt.addParam(prefix));
	}

	public boolean existBy(String prefix) {
		return retrieveBy(prefix).getRowCount() > 0;
	}

	public NRows retrieveBy(String prefix) {
		IUserProcedure upt = createUserProcedure("nodetype@retrieveNSBy(?)") ;
		return execNQuery(upt.addParam(prefix));
	}

	public NRows listBy() {
		IUserProcedure upt = createUserProcedure("nodetype@listNSBy()") ;
		return execNQuery(upt);
	}

}
