package com.bleujin.lore.core.dimpl.carrier;

import com.bleujin.framework.db.DBController;
import com.bleujin.framework.db.NRows;
import com.bleujin.framework.db.procedure.IUserProcedure;
import com.bleujin.lore.core.common.IDString;

public class PropertyCarrier extends Carrier{

	public PropertyCarrier(DBController dc) {
	    super(dc);
    }

	public int set(String uuid, String pId, String value) {
		IUserProcedure upt = createUserProcedure("property@set(?,?,?)") ;
		upt.addParam(0, uuid) ;
		upt.addParam(1, pId) ;
		upt.addParam(2, value) ; // FIXME : binary, text
		
		return execUpdate(upt) ;
    }

	public NRows getProperties(String uuId, int versionNum) {
		IUserProcedure upt = createUserProcedure("property@listBy(?,?)") ;
		upt.addParam(uuId).addParam(versionNum) ;
		
		return execNQuery(upt);
	}

	public NRows getValues(String uuid, IDString propId, int versionNum) {
		IUserProcedure upt = createUserProcedure("property@arrayListBy(?,?,?)") ;
		upt.addParam(uuid).addParam(propId).addParam(versionNum) ;
		return execNQuery(upt);
	}
	
	

}
