package com.bleujin.lore.core.dimpl.carrier;

import com.bleujin.framework.db.DBController;
import com.bleujin.framework.db.NRows;
import com.bleujin.framework.db.RepositoryException;
import com.bleujin.framework.db.Row;
import com.bleujin.framework.db.Rows;
import com.bleujin.framework.db.procedure.IUserProcedure;
import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.exception.ShareNodeException;

public class ShareCarrier extends Carrier{

	public ShareCarrier(DBController dc) {
		super(dc);
	}

	public int shareNode(String shareName, String workspaceName, String nodePath, boolean enableWrite) {
		IUserProcedure upt = createUserProcedure("shareNode@createInfoWith(?,?,?,?)") ;
		upt.addParam(0, shareName) ;
		upt.addParam(1, workspaceName) ;
		upt.addParam(2, nodePath) ;  
		upt.addParam(3, enableWrite ? T : F) ;
		return execUpdate(upt) ;
	}

	public Row getNodeInfo(String shareName) throws ALRepositoryException {
		IUserProcedure upt = createUserProcedure("shareNode@retrieveInfoBy(?)") ;
		upt.addParam(0, shareName) ;
		Rows rows = execQuery(upt) ;
		
		try {
			return rows.firstRow() ;
		} catch(RepositoryException ex){
			throw new ShareNodeException("not found shareInfo : " + shareName) ;
		}
	}

	public NRows getNodeInfos() {
		IUserProcedure upt = createUserProcedure("shareNode@listBy()") ;
		return execNQuery(upt) ;
	}

}
