package com.bleujin.lore.core.dimpl.carrier;

import com.bleujin.framework.db.DBController;
import com.bleujin.framework.db.NRows;
import com.bleujin.framework.db.procedure.IUserProcedure;
import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.nodetype.NodeTypeId;
import com.bleujin.lore.extend.template.TemplateId;

public class TemplateCarrier extends Carrier {

	public TemplateCarrier(DBController dc) {
		super(dc);
	}

	public NRows getTemplate(String identifier, NodeTypeId typeId) throws ALRepositoryException {
		IUserProcedure upt = createUserProcedure("template@mappingBy(?, ?)") ;
		upt.addParam(identifier).addParam(typeId) ;
		return execNQuery(upt);
	}

	public NRows getTemplate(TemplateId tplId) {
		IUserProcedure upt = createUserProcedure("template@retrieveBy(?)") ;
		upt.addParam(tplId) ;
		return execNQuery(upt);
	}

	public int create(TemplateId tplId, String content) {
		IUserProcedure upt = createUserProcedure("template@createWith(?, ?)") ;
		upt.addParam(tplId).addParam(content) ;
		return execUpdate(upt);
	}

	public int setTemplate(String identifier, TemplateId tplId) {
		IUserProcedure upt = createUserProcedure("template@mappingWith(?, ?)") ;
		upt.addParam(identifier).addParam(tplId) ;
		return execUpdate(upt);
	}

	public NRows getTemplates() {
		IUserProcedure upt = createUserProcedure("template@listBy()") ;
		return execNQuery(upt);
	}

}
