package com.bleujin.lore.core.dimpl.carrier;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import com.bleujin.framework.db.DBController;
import com.bleujin.framework.db.NRows;
import com.bleujin.framework.db.procedure.IUserProcedure;
import com.bleujin.framework.util.DateUtil;
import com.bleujin.lore.core.bean.Register;
import com.bleujin.lore.core.dimpl.DatabaseVersionHistory;
import com.bleujin.lore.core.dimpl.VersionDBImpl;
import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.node.NodeVersion;
import com.bleujin.lore.core.node.VersionHistory;

public class VersionCarrier extends Carrier{

	public VersionCarrier(DBController dc) {
		super(dc);
	}

	public VersionHistory historyBy(Node node) throws ALRepositoryException {
		IUserProcedure upt = createUserProcedure("version@listBy(?)") ;
		upt.addParam(node.getIdentifier()) ;
		NRows rows = execNQuery(upt) ;
		List<NodeVersion> result = new ArrayList<NodeVersion>() ;

		while(rows.next()){
			Calendar modDay = DateUtil.stringToCalendar(rows.getString("modDay"));
			Register register = new Register(rows.getString("modUserId"), modDay) ;
			VersionDBImpl version = VersionDBImpl.load(node, rows.getInt("versionNum")+1, register);
			result.add(version) ;
		}

		// result.add(0, VersionDBImpl.load(node, 0, node.getBean().getRegister())) ;
		Node refresh = node.getNode(Node.ID_BEGIN_MARK + node.getIdentifier() + Node.ID_END_MARK);
		DatabaseVersionHistory his =  new DatabaseVersionHistory(result, refresh) ;
		return his ;
	}


}
