package com.bleujin.lore.core.dimpl.carrier;

import com.bleujin.framework.db.DBController;
import com.bleujin.framework.db.procedure.IUserProcedure;
import com.bleujin.lore.core.common.IDString;

public class WorkspaceCarrier extends Carrier {

	public WorkspaceCarrier(DBController dc) {
		super(dc);
	}

	public int reset(IDString seqId) {
		IUserProcedure upt = createUserProcedure("workspace@reset(?)");
		upt.addParam(0, seqId);

		return execUpdate(upt);
	}

	public long currVal(IDString seqId) {
		IUserProcedure upt = createUserProcedure("workspace@currval(?)");
		upt.addParam(0, seqId);

		return execUpdate(upt);
	}

	public long nextVal(IDString seqId) {
		IUserProcedure upt = createUserProcedure("workspace@nextval(?)");
		upt.addParam(0, seqId);

		return execUpdate(upt);
	}
	
	public long prepareVal(IDString seqId, int prepareCache){
		IUserProcedure upt = createUserProcedure("workspace@prepare(?,?)");
		upt.addParam(seqId).addParam(prepareCache);

		return execUpdate(upt);
	}
 

}
