package com.bleujin.lore.core.link;

import java.io.Serializable;

import com.bleujin.lore.core.common.IConstant;
import com.bleujin.lore.core.common.Publishable;
import com.bleujin.lore.core.dimpl.UserSession;
import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.link.LinkType.Position;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.observation.Event.Mode;

public interface Link extends IConstant, Publishable, Serializable {

	public void setMode(Mode mode);

	public Mode getMode();

	public Node getFrom() throws ALRepositoryException;

	public LinkType getType();

	public Node getTo() throws ALRepositoryException;

	public String getFromId();

	public String getToId();

	public Position getPosition();

	public Link newClone(UserSession session);
}
