package com.bleujin.lore.core.mapping;


import com.bleujin.framework.util.StringUtil;
import com.bleujin.lore.core.common.IDString;
import com.bleujin.lore.core.value.Value;

public class AlphaNumUnderbarConstraint implements IValueConstraint {

	private static final long serialVersionUID = 5015546869883637050L;

	public ValidMessage getValidMessage(IDString propId, Value value) {
		return ValidMessage.create(isValid(value), propId + " should be alphabetic or numberic or underbar") ;
	}

	public boolean isValid(Value value) {
		return StringUtil.isAlphanumericUnderbar(value.getString()) ;
	}
	
	public String getUniqueName(){
		return getClass().getName() ;
	}

	public String getConfigurationExpression(){
		String str = "" +
		"<configured-object>\n" + 
        "<class-name>" + getClass().getName()+ "</class-name>\n" +
        "</configured-object>" ;
		return str ;
	}	
}