package com.bleujin.lore.core.mapping;

import org.apache.commons.lang.math.RandomUtils;

import com.bleujin.framework.configuration.ConfigurationException;
import com.bleujin.framework.configuration.ConfigurationFactory;
import com.bleujin.framework.configuration.DefaultConfigurationFactory;
import com.bleujin.framework.util.InstanceCreator;
import com.bleujin.framework.util.StringUtil;
import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.io.StringInputStream;

public class ConstraintHelper {

	// TODO -_-;;
	public static synchronized IValueConstraint makeConstraint(String expression) throws ALRepositoryException  {
		try {
			if (StringUtil.isBlank(expression)) return IValueConstraint.NONE ;
			
			String key = new String("" + RandomUtils.nextInt()) ;
			
			ConfigurationFactory config = TemporaryConfigurationFactory.getInstance(key) ;
			config.build(new StringInputStream("<?xml version=\"1.0\" encoding=\"UTF-16\"?>\n\n" + expression)) ;
			IValueConstraint constraint =  (IValueConstraint)InstanceCreator.createConfiguredInstance(config.getConfiguration("configured-object")) ;

			TemporaryConfigurationFactory.removeConfiguration(key) ;
			
			return constraint ;
		} catch (Exception e) {
			throw new ALRepositoryException(e + expression) ;
		}
	}

	public static synchronized IDefaultValue makeDefaultValue(String expression) throws ALRepositoryException {
		try {
			if (StringUtil.isBlank(expression)) return IDefaultValue.NONE ;
			
			String key = new String("" + RandomUtils.nextInt()) ;
			
			ConfigurationFactory config = TemporaryConfigurationFactory.getInstance(key) ;
			config.build(new StringInputStream("<?xml version=\"1.0\" encoding=\"UTF-16\"?>\n\n" + expression)) ;
			IDefaultValue defaultValue =  (IDefaultValue)InstanceCreator.createConfiguredInstance(config.getConfiguration("configured-object")) ;

			TemporaryConfigurationFactory.removeConfiguration(key) ;
			
			return defaultValue ;
		} catch (Exception e) {
			throw new ALRepositoryException(e + expression) ;
		}
	}
	
//	public static synchronized IValueConstraint makeConstraint(String expression) throws RepositoryException  {
//		try {
//			ConfigurationFactory config = ConfigurationFactory.createInstance("default") ;
//			
//			Debug.debug(this, config.getClass().getName());
//			
//			
//			config.build(new StringInputStream("<?xml version=\"1.0\" encoding=\"UTF-16\"?>\n\n" + expression)) ;
//			Configuration c2 = config.getConfiguration("configured-object") ;
//			Debug.debug(this, c2);
//			IValueConstraint constraint =  (IValueConstraint)InstanceCreator.createConfiguredInstance(config.getConfiguration("configured-object")) ;
//
//			// TemporaryConfigurationFactory.removeConfiguration("default") ;
//			
//			return constraint ;
//		} catch (Exception e) {
//			throw new RepositoryException(e) ;
//		}
//	}
}

class TemporaryConfigurationFactory extends DefaultConfigurationFactory {

	public TemporaryConfigurationFactory() {
		super("temporaryFactory");
	}

	public static ConfigurationFactory getInstance(String configName) throws ConfigurationException {
		return ConfigurationFactory.getInstance(configName);
	}

	public static void removeConfiguration(String configName) { // for security...
		ConfigurationFactory.removeConfiguration(configName);
	}

}
