package com.bleujin.lore.core.mapping;


import com.bleujin.framework.util.StringUtil;
import com.bleujin.lore.core.common.IDString;
import com.bleujin.lore.core.value.Value;

public class ContainSpecialCharConstraint implements IValueConstraint {

	private static final long serialVersionUID = -7218247947548836564L;
	public ValidMessage getValidMessage(IDString propId, Value value) {
		return ValidMessage.create(isValid(value), propId + " should be included special-char(except alpha, num, underbar)") ;
	}

	public boolean isValid(Value value) {
		return StringUtil.isNotBlank(value.getString()) && (!StringUtil.isAlphanumericUnderbar(value.getString())) ;
	}

	public String getUniqueName(){
		return getClass().getName() ;
	}
	public String getConfigurationExpression(){
		String str = "" +
		"<configured-object>\n" + 
        "<class-name>" + getClass().getName()+ "</class-name>\n" +
        "</configured-object>" ;
		return str ;
	}
}
