package com.bleujin.lore.core.mapping;


import com.bleujin.framework.util.DateUtil;
import com.bleujin.lore.core.common.IDString;
import com.bleujin.lore.core.value.Value;

public class DateConstraint implements IValueConstraint {
 
	private static final long serialVersionUID = -916198541605958875L;
	private String dateFormat ;
	public DateConstraint(){
		this("yyyyMMdd-HHmmss") ;
	}
	
	public DateConstraint(String dateFormat) {
	    this.dateFormat = dateFormat ;
    }

	public ValidMessage getValidMessage(IDString propId, Value value) {
		return ValidMessage.create(isValid(value), propId + " should be date type") ;
	}

	public boolean isValid(Value value) {
		try {
			DateUtil.stringToDate(value.getString(), this.dateFormat) ;
			return true ;
		} catch(IllegalArgumentException ignore){
			return false ;
		}
	}
	
	public String getConfigurationExpression(){
		String str = "" +
		"<configured-object>\n" + 
        "<class-name>" + getClass().getName()+ "</class-name>\n" +
        "</configured-object>" ;
		return str ;
	}
}
