package com.bleujin.lore.core.mapping;


import org.apache.commons.validator.GenericValidator;

import com.bleujin.framework.util.StringUtil;
import com.bleujin.lore.core.common.IDString;
import com.bleujin.lore.core.value.Value;

public class DoubleConstraint implements IValueConstraint {
 
	private static final long serialVersionUID = -5898808149979769522L;

	public ValidMessage getValidMessage(IDString propId, Value value) {
		return ValidMessage.create(isValid(value), propId + " should be numeric(double format)") ;
	}

	public boolean isValid(Value value) {
		if (StringUtil.isBlank(value.getString())) return true ;
		return GenericValidator.isDouble(value.getString()) ;
	}

	public String getConfigurationExpression(){
		String str = "" +
		"<configured-object>\n" + 
        "<class-name>" + getClass().getName()+ "</class-name>\n" +
        "</configured-object>" ;
		return str ;
	}
}
