package com.bleujin.lore.core.mapping;


import com.bleujin.framework.util.StringUtil;
import com.bleujin.lore.core.common.IDString;
import com.bleujin.lore.core.value.Value;

public class IDConstraint implements IValueConstraint {
 
	private static final long serialVersionUID = -3915660673446918072L;

	public ValidMessage getValidMessage(IDString propId, Value value) {
		return ValidMessage.create(isValid(value), propId + " should be small-alphabetic or numberic") ;
	}

	public boolean isValid(Value value) {
		return StringUtil.isSmallAlphaNumUnderBar(value.getString()) && (!value.getString().startsWith("_")) ;
	}

	public String getConfigurationExpression(){
		String str = "" +
		"<configured-object>" + "\n" + 
        "<class-name>" + getClass().getName()+ "</class-name>" + "\n" +
        "</configured-object>" ;
		return str ;
	}
}
