package com.bleujin.lore.core.mapping;

import com.bleujin.lore.core.node.Property;
import com.bleujin.lore.core.node.Property.Type;
import com.bleujin.lore.core.value.Value;

public class LongDefaultValue implements IDefaultValue{
 
	private static final long serialVersionUID = -6599059115284296667L;
	private long value ;
	public LongDefaultValue(long value){
		this.value = value ;
	}
	
	
	public String getConfigurationExpression() {
		String str = "" +
		"<configured-object>\n" + 
        "<class-name>" + getClass().getName()+ "</class-name>\n" +
        "<constructor>\n" +
        "    <constructor-param>\n" +
        "        <description>default Value</description>\n" +
        "        <type>long</type>\n" +
        "        <value>" + value + "</value>\n" +
        "    </constructor-param>\n" +
        "</constructor>\n" +
        "</configured-object>" ;
		return str ;
	}

	public Value getValue() {
		return Value.longValue(value);
	}

	public boolean isAcceptableType(Type type) {
		return  (type == Property.Type.LONG)
	  		|| (type == Property.Type.DOUBLE) 
	  		|| (type == Property.Type.STRING);
	}

}
