package com.bleujin.lore.core.mapping;


import com.bleujin.framework.util.StringUtil;
import com.bleujin.lore.core.common.IDString;
import com.bleujin.lore.core.value.Value;

public class NumberConstraint implements IValueConstraint {
 
	private static final long serialVersionUID = -3740988796121106409L;

	public ValidMessage getValidMessage(IDString propId, Value value) {
		return ValidMessage.create(isValid(value), propId + " should be numeric") ;
	}

	public boolean isValid(Value value) {
		String about = value.getString();
		return StringUtil.isNumeric(about) || (about.startsWith("-") && StringUtil.isNumeric(StringUtil.substring(about, 1))) ;
	}
	
	public String getConfigurationExpression(){
		String str = "" +
		"<configured-object>" + "\n" + 
        "<class-name>" + getClass().getName()+ "</class-name>" + "\n" +
        "</configured-object>" ;
		return str ;
	}
}
