package com.bleujin.lore.core.mapping;

import java.text.MessageFormat;

import com.bleujin.lore.core.common.IDString;
import com.bleujin.lore.core.value.Value;

public class RequireConstraint implements IValueConstraint{
 
	private static final long serialVersionUID = -2455730746377443519L;
	public boolean isValid(Value value) {
	    return ! value.isBlank();
    }

	public ValidMessage getValidMessage(IDString propId, Value value){
		return ValidMessage.create(isValid(value), MessageFormat.format("{0} is required.", new Object[]{ propId})) ;
	}

	
	public String getConfigurationExpression(){
		String str = "" +
		"<configured-object>\n" + 
        "<class-name>" + getClass().getName()+ "</class-name>\n" +
        "</configured-object>" ;
		return str ;
	}
}
