package com.bleujin.lore.core.mapping;

import com.bleujin.lore.core.node.Property;
import com.bleujin.lore.core.node.Property.Type;
import com.bleujin.lore.core.value.Value;

public class StringDefaultValue implements IDefaultValue{
 
	private static final long serialVersionUID = -9002479358617306026L;
	private String value ;
	public StringDefaultValue(String value){
		this.value = value ;
	}
	
	
	public String getConfigurationExpression() {
		String str = "" +
		"<configured-object>\n" + 
        "<class-name>" + getClass().getName()+ "</class-name>\n" +
        "<constructor>\n" +
        "    <constructor-param>\n" +
        "        <description>default Value</description>\n" +
        "        <type>java.lang.String</type>\n" +
        "        <value>" + value + "</value>\n" +
        "    </constructor-param>\n" +
        "</constructor>\n" +
        "</configured-object>" ;
		return str ;
	}

	public Value getValue() {
		return Value.stringValue(value);
	}

	public boolean isAcceptableType(Type type) {
		return (type == Property.Type.STRING) 
	  		|| (type == Property.Type.VIRTUAL_TEXT) 
	  		|| (type == Property.Type.TEXT) ;
	}

}
