package com.bleujin.lore.core.migration;

import java.io.FileInputStream;
import java.io.IOException;

import com.bleujin.framework.db.bean.handlers.CSVReader;

public class CSVFileReader implements IReader{

	private String fileName ;
	private String encoding ;
	private CSVReader reader ;
	
	public CSVFileReader(String name){
		this(name, "UTF-8") ;
	}
	
	public CSVFileReader(String name, String encoding){
		this.fileName = name ;
		this.encoding = encoding ;
	}
	
	public void open() throws IOException{
		reader = new CSVReader(new FileInputStream(fileName), encoding) ;
	}
	
	public String[] readData() throws IOException {
		return reader.getLine() ;
    }

	public String[] readHeader() throws IOException {
		return reader.getLine() ;
    }

	public void close() throws IOException {
		reader.close() ;
	}

}
