package com.bleujin.lore.core.migration;

import java.io.File;
import java.io.IOException;

import com.bleujin.framework.db.bean.handlers.CSVWriter;

public class CSVFileWriter implements IWriter{

	private String fileName ;
	private String encoding ;
	private CSVWriter writer ;
	
	public CSVFileWriter(String fileName){
		this(fileName, "UTF-8") ;
	}
	
	public CSVFileWriter(String fileName, String encoding){
		this.fileName = fileName ;
		this.encoding = encoding ;
	}
	
	public void open() throws IOException{
		File file = new File(fileName);
		if(! file.getParentFile().exists()) file.getParentFile().mkdirs() ;
		writer = new CSVWriter(file, encoding) ;
	}
	
	public void writeData(String[] data) throws IOException {
		writer.writeData(data) ;
    }

	public void writeHeader(String[] header) throws IOException {
		writer.writeHeader(header);
    }

	public void close() throws IOException {
		writer.close() ;
	}
}
