package com.bleujin.lore.core.migration;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.collections.CollectionUtils;

import com.bleujin.lore.core.dimpl.UserSession;
import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.node.INode;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.nodetype.NodeType;

public class Data2Node {

	private UserSession session ;
	private Node parent ;
	private NodeType nodetype ;

	public Data2Node(UserSession session, Node parent, NodeType nodetype){
		this.session = session ;
		this.parent = parent ;
		this.nodetype = nodetype ;
	}
	
	
	public INode toNode(String[] data) throws ALRepositoryException {
		
		INode newNode = session.createNode(parent, nodetype, get(data, "name"), get(data, "explain")) ;
		newNode.setProperty("explain", get(data, "explain", 1)) ;
		
		return newNode;
	}

	
	private String get(String[] data, String name){
		return data[findIndex(name, 0)] ;
	}

	private String get(String[] data, String name, int ordinal){
		return data[findIndex(name, ordinal)] ;
	}

	private int findIndex(String name, int ordinal) {
		
		int foundOrdinal = 0 ;
		int index = 0 ;
		for(String header : headerName){
			if (header.equals(name) && foundOrdinal++ == ordinal){
				return index ; 
			}
			index++ ;
		}
		throw new IllegalArgumentException(name + "["+ ordinal + "] not found in header") ;
	}
	
	private List<String> headerName = new ArrayList<String>();
	public void setHeader(String[] header) throws ALRepositoryException {
		CollectionUtils.addAll(headerName, header) ;
	}
}
