package com.bleujin.lore.core.migration;

import java.io.IOException;

import com.bleujin.lore.core.common.GenericIterator;
import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.node.Node;

public class DefaultExporter implements Exporter {

	private GenericIterator<Node> sources;
	private IGetter getter;
	private IWriter writer;

	public DefaultExporter(GenericIterator<Node> sources, IGetter getter, IWriter writer) {
		this.sources = sources;
		this.getter = getter;
		this.writer = writer;
	}

	public void exp() throws IOException, ALRepositoryException {
		writer.open();
		writer.writeHeader(getter.getHeader());
		for (Node node : sources) {
			writer.writeData(getter.getData(node));
		}
		writer.close();
	}

}
