package com.bleujin.lore.core.migration;

import java.util.List;

import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.nodetype.MappedDefinition;
import com.bleujin.lore.core.nodetype.NodeType;

public class NodeTypeGetter implements IGetter {

	
	private NodeType nodeType ;
	public NodeTypeGetter(NodeType nodeType) {
	    this.nodeType = nodeType ;
    }

	private int predefined = 4;
	public String[] getData(Node node) throws ALRepositoryException {
		List<MappedDefinition> mds = nodeType.getMappedDefinitions().toList() ;
		String[] result = new String[predefined + mds.size()] ;
		result[0] = node.getName() ;
		result[1] = node.getIdentifier() ;
		result[2] = node.getPath() ;
		result[3] = node.getExplain() ;
		for (int i = predefined, last = result.length; i < last; i++) {
	        result[i] =  node.getProperty(mds.get(i-predefined).getName()).getString() ;
        }

		return result;
	}

	public String[] getHeader() throws ALRepositoryException {
		List<MappedDefinition> mds = nodeType.getMappedDefinitions().toList() ;
		String[] result = new String[predefined + mds.size()] ;
		result[0] = "name" ;
		result[1] = "uuid" ;
		result[2] = "path" ;
		result[3] = "explain";
		for (int i = predefined, last = result.length; i < last; i++) {
	        result[i] = mds.get(i-predefined).getName() ;
        }

		return result;
	}

}
