package com.bleujin.lore.core.migration;

import java.io.IOException;
import java.io.OutputStream;

import org.apache.commons.lang.SystemUtils;

public class SystemOutWriter implements IWriter{

	private OutputStream output ;
	private String charsetName ;
	public SystemOutWriter(OutputStream output, String charsetName){
		this.output = output ;
		this.charsetName = charsetName ;
	}
	
	public void close() throws IOException {
	    output.close() ;
    }

	public void open() throws IOException {
    }

	public void writeData(String[] data) throws IOException {
		StringBuilder result = new StringBuilder() ;
		
		for (int i = 0, last = data.length; i < last; i++) {
			result.append(data[i]) ;
			result.append((i != (data.length-1) ? "," : "")) ;
        }
		result.append(SystemUtils.LINE_SEPARATOR) ;
		
		output.write(result.toString().getBytes(charsetName)) ;
    }

	public void writeHeader(String[] header) throws IOException {
		writeData(header) ;
    }

}
