package com.bleujin.lore.core.migration;

import java.util.ArrayList;
import java.util.List;

import com.bleujin.lore.core.TestCaseParent;
import com.bleujin.lore.core.common.GenericIterator;
import com.bleujin.lore.core.common.GenericIteratorHelper;
import com.bleujin.lore.core.mapping.RequireConstraint;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.node.Property;
import com.bleujin.lore.core.nodetype.NodeType;
import com.bleujin.lore.core.nodetype.NewNodeType;
import com.bleujin.lore.core.nodetype.PropertyDefinition;

public class TestExporter extends TestCaseParent{
	
	private NodeType robot = null ; 
	private String explain = "explain";
	private List<Node> list = new ArrayList<Node>() ;
	
	public void setUp() throws Exception {
		super.setUp() ;
		PropertyDefinition explainPd = createPropertyDefinition(explain, Property.Type.STRING) ;
		NewNodeType newType = createNewNodeType(objectType, "robot", new PropertyDefinition[]{explainPd}) ;
		newType.setConstraint(explainPd, new RequireConstraint()) ;
		robot = registerNodeType(newType) ; 

		
		Node p2 = saveNode(robot, "p2") ;
		p2.setProperty(explain, "180cm, 210kg의 몸으로 사람의 보행을 최초로 구현해낸 로봇") ;
		list.add(p2) ;
		
		Node asimo = saveNode(robot, "asimo") ;
		asimo.setProperty(explain, "2000년 11월 혼다의 아시모") ;
		list.add(asimo) ;
	}
	
	public void tearDown() throws Exception {
		super.tearDown() ;
		list.clear() ;
	}
	
	String fileName = "c:/111.txt";
	public void testDefaultCSV() throws Exception {
		GenericIterator<Node> sources = new GenericIteratorHelper<Node>(list) ;
		DefaultExporter exp = new DefaultExporter(sources,  new NodeGetter(), new CSVFileWriter(fileName)) ;
	    exp.exp() ;
    }

	public void testSystemOut() throws Exception {
		GenericIterator<Node> sources = new GenericIteratorHelper<Node>(list) ;
	    DefaultExporter exp = new DefaultExporter(sources,  new NodeTypeGetter(robot), new SystemOutWriter(System.out, "UTF-8")) ;
	    // exp.exp() ;
    }
	
	public void testGetter() throws Exception {
		GenericIterator<Node> sources = new GenericIteratorHelper<Node>(list) ;
		DefaultExporter exp = new DefaultExporter(sources,  new NodeTypeGetter(robot), new SystemOutWriter(System.out, "UTF-8")) ;
		// exp.exp() ;
	    
	    sources = new GenericIteratorHelper<Node>(list) ;
		exp = new DefaultExporter(sources,  new NodeTypeGetter(robot), new CSVFileWriter(fileName)) ;
		// exp.exp() ;
	}

	
	
}
