package com.bleujin.lore.core.migration;

import java.util.ArrayList;
import java.util.List;

import com.bleujin.lore.core.TestCaseParent;
import com.bleujin.lore.core.common.GenericIterator;
import com.bleujin.lore.core.common.GenericIteratorHelper;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.nodetype.NodeType;

public class TestImporter extends TestCaseParent {

	private NodeType robot = null ; 
	private String explain = "explain";
	private List<Node> list = new ArrayList<Node>() ;
	
	public void setUp() throws Exception {
		super.setUp() ;
		robot = getRobotType() ;
		
		Node p2 = saveNode(robot, "p2") ;
		p2.setProperty(explain, "180cm, 210kg의 몸으로 사람의 보행을 최초로 구현해낸 로봇") ;
		list.add(p2) ;
		
		Node asimo = saveNode(robot, "asimo") ;
		asimo.setProperty(explain, "2000년 11월 혼다의 아시모") ;
		list.add(asimo) ;
	}
	
	public void tearDown() throws Exception {
		super.tearDown() ;
		list.clear() ;
	}
	
	private String fileName = "d:/anotherlore/test/export_default.txt";
	private void makeDefaultCSV(IGetter getter) throws Exception {
		GenericIterator<Node> sources = new GenericIteratorHelper<Node>(list) ;
		DefaultExporter exp = new DefaultExporter(sources,  getter, new CSVFileWriter(fileName)) ;
	    exp.exp() ;
    }
	
//	public void xtestDefaultCSVReader() throws Exception {
//		makeDefaultCSV(new NodeGetter()) ;
//		Node exportRoot = createNode(root, objectType, "export_node") ;
//		
//		DefaultImporter imp = new DefaultImporter(new INodeTarget(), new Data2Node(session, exportRoot, robot), new CSVFileReader(fileName)) ;
//		imp.imp() ;
//		
//		//session.getLocalStore().confirm() ;
//		
//	}
	
	public void testExtendCSVReader() throws Exception {
		makeDefaultCSV(new NodeTypeGetter(robot)) ;
		Node exportRoot = saveNode(objectType, "export_node") ;
		
		DefaultImporter imp = new DefaultImporter(new INodeTarget(), new Data2Node(session, exportRoot, robot), new CSVFileReader(fileName)) ;
		imp.imp() ;
		
		// session.save() ;
		session.getLocalStore().confirm(session) ;
		
	}
}
