package com.bleujin.lore.core.migration;

import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.Reader;
import java.io.StringReader;
import java.io.UnsupportedEncodingException;

import javax.xml.transform.Result;
import javax.xml.transform.Templates;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;

import org.apache.commons.io.output.DeferredFileOutputStream;
import org.apache.ecs.xml.XML;

import com.bleujin.lore.core.exception.MigrationException;
import com.bleujin.lore.core.util.Utils;

public class XSLTTranslator {
	public XSLTTranslator() {
	}

	static InputStream trans(String xmlStr, Reader xsl) throws UnsupportedEncodingException, MigrationException, TransformerConfigurationException, TransformerException, IOException {
		File file = File.createTempFile("export", "trans");
		DeferredFileOutputStream out = new DeferredFileOutputStream(1000000, file); // 1M
		Result result = new StreamResult(out);

		TransformerFactory factory = TransformerFactory.newInstance();
		StreamSource xslSource = new StreamSource(xsl);
		Templates templates = factory.newTemplates(xslSource);
		Transformer transformer = templates.newTransformer();
		transformer.transform(new StreamSource(new StringReader(Utils.escapeControlChar(xmlStr))), result);
		return new ByteArrayInputStream(out.getData());
	}

	static void trans(XML xml, OutputStream output, Reader xsl) throws IOException, TransformerConfigurationException, TransformerException, MigrationException, UnsupportedEncodingException {
		trans(xml.toString(), output, xsl);
	}

	static void trans(String xmlStr, OutputStream output, Reader xsl) throws UnsupportedEncodingException, MigrationException, TransformerConfigurationException, TransformerException, IOException {
		Result result = new StreamResult(output);

		TransformerFactory factory = TransformerFactory.newInstance();
		StreamSource xslSource = new StreamSource(xsl);
		Templates templates = factory.newTemplates(xslSource);
		Transformer transformer = templates.newTransformer();
		transformer.transform(new StreamSource(new StringReader(Utils.escapeControlChar(xmlStr))), result);
	}

}
