package com.bleujin.lore.core.migration.sample;

import com.bleujin.framework.db.DBController;
import com.bleujin.framework.db.Rows;
import com.bleujin.framework.db.manager.Oracle9iCacheDBManager;
import com.bleujin.lore.core.TestCaseParent;
import com.bleujin.lore.core.common.GenericIterator;
import com.bleujin.lore.core.common.Page;
import com.bleujin.lore.core.link.LinkType;
import com.bleujin.lore.core.node.Node;

public class TestSampleImporter extends TestCaseParent{

	public void testDefault() throws Exception {
		assertEquals(null, null) ;
	}
	
	public void xtestImport() throws Exception {
		Node testFirstNode = createTestNode() ;
		
		Oracle9iCacheDBManager dbm = new Oracle9iCacheDBManager("jdbc:oracle:thin:@novision:1521:bleujin", "scott", "tiger") ;
		dbm.initPoolConnection() ;
		DBController dc = new DBController(dbm) ;

		Node empRootNode = session.createNode(testFirstNode, objectType, "scott_emp").save() ;
		Rows empRow = dc.getRows("Select * From emp") ;
		EmpImporter eimp = new EmpImporter(session, empRow) ;
		eimp.imp() ;

		// confirm emp 
		assertEquals(14, empRootNode.getChildNode().size()) ;
		
		Node smith = session.getNode("/scott_emp/SMITH") ;
		LinkType managerLink = session.createLinkType("manager") ;
		GenericIterator<Node> manager = smith.getNodes(managerLink, Page.ALL) ;

		assertEquals(1, manager.size()) ;
		assertEquals("FORD", manager.next().getProperty("eName").getString()) ;

		
		Node deptRootNode = session.createNode(testFirstNode, objectType, "scott_dept").save() ;
		Rows deptRow = dc.getRows("select * From dept") ;
		DeptImporter dimp = new DeptImporter(session, deptRow) ;
		dimp.imp() ;
		
		// confirm dept
		assertEquals(4, deptRootNode.getChildNode().size()) ;
		Node sales = session.getNode("/scott_dept/SALES");

		assertEquals("SALES", sales.getProperty("dName").getString()) ;
		LinkType belongTo = session.createLinkType("belongTo") ;
		GenericIterator<Node> salesEmployee = sales.getNodes(belongTo, Page.ALL);
		assertEquals(6, salesEmployee.size()) ;
		
		
		
		

		
		
		// destroy database 
		dc._destroy() ;
    }
}
