package com.bleujin.lore.core.node;

import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.exception.AccessDeniedException;
import com.bleujin.lore.core.exception.ItemNotFoundException;
import com.bleujin.lore.core.link.LinkType;
import com.bleujin.lore.core.link.LinkType.Position;
import com.bleujin.lore.core.observation.Event.Mode;

public interface INode extends INodeCommon {
	
	public Mode getMode();

	public Node save() throws ALRepositoryException;
	public Node getNode(String path) throws ALRepositoryException ;
	public void setParent(Node node) throws ALRepositoryException ;
	public Node getParent() throws ItemNotFoundException, AccessDeniedException, ALRepositoryException;
	public void addLink(Node target, LinkType linkType, Position position) throws ALRepositoryException;

}
