package com.bleujin.lore.core.node;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Calendar;
import java.util.Date;

import com.bleujin.lore.core.bean.Register;
import com.bleujin.lore.core.common.GenericIterator;
import com.bleujin.lore.core.common.Publishable;
import com.bleujin.lore.core.dimpl.UserSession;
import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.exception.IllegalNodeNameException;
import com.bleujin.lore.core.mapping.ValidMessage;
import com.bleujin.lore.core.nodetype.NodeType;
import com.bleujin.lore.core.nodetype.NodeTypeId;
import com.bleujin.lore.core.value.Value;

public interface INodeCommon extends Publishable, Serializable {
	public boolean isRoot() ;
	public String getPath() throws ALRepositoryException;

	public void setName(String name) throws IllegalNodeNameException;
	public String getName();
	public void setExplain(String explain) ;
	public String getExplain() ;
	public String getIdentifier();
	public String getUUIDString() ;
	public String getWorkspaceName();
	public NodeTypeId getNodeTypeId();
	public NodeType getNodeType() throws ALRepositoryException;
	public Register getRegister() ;
	public Calendar getCreated() ;

	public GenericIterator<ValidMessage> getViolateConstraintMessage() throws ALRepositoryException ;

	public void setProperty(String propId, Object value) throws ALRepositoryException;
	public void setProperty(String propId, String value) throws ALRepositoryException;
	public void setProperty(String propId, BinaryPropertyValue value) throws ALRepositoryException;
	public void setProperty(String propId, boolean value) throws ALRepositoryException;
	public void setProperty(String propId, int value) throws ALRepositoryException;
	public void setProperty(String propId, BigDecimal value) throws ALRepositoryException;
	public void setProperty(String propId, long value) throws ALRepositoryException;
	public void setProperty(String propId, Calendar value) throws ALRepositoryException;
	public void setProperty(String propId, Date value) throws ALRepositoryException;
	public void setProperty(String propId, Value value) throws ALRepositoryException;
	public void setProperty(String[] propId, Object[] value) throws ALRepositoryException;

	public boolean hasProperties() throws ALRepositoryException;
	public boolean hasProperty(String propId) throws ALRepositoryException;
	public GenericIterator<Property> getProperties() throws ALRepositoryException;
	public Property getProperty(String propId) throws ALRepositoryException;
	public String getString(String propId) throws ALRepositoryException;
	public Value getValue(String propId) throws ALRepositoryException;
	
	public void setDefaultProperty() throws ALRepositoryException;
	
	public UserSession getSession() ;
	
}
