package com.bleujin.lore.core.node;

import java.io.Serializable;
import java.io.UnsupportedEncodingException;

import com.bleujin.framework.db.procedure.IStringObject;
import com.bleujin.framework.util.StringUtil;
import com.bleujin.lore.core.exception.IllegalNodeNameException;

// immutable
public final class NodeName implements IStringObject, Serializable{
 
	private static final long serialVersionUID = 1662859392195863726L;

	public final static NodeName ROOT_NAME = new NodeName("/") ;
	
	private String name ;
	public NodeName(String name) {
		this.name = name ;
	}

	private static NodeName create(String id, int minLength, int maxLength) throws IllegalNodeNameException{
		try {
			if (StringUtil.indexOfAny(id, new char[]{'\\', '/', ':', '*', '?', '"', '<', '>', '|'}) > -1 ||
					id.getBytes("UTF-8").length > maxLength || id.length() < minLength ) {
				throw new IllegalNodeNameException(id) ;
			}
		} catch(UnsupportedEncodingException ignore){
			ignore.printStackTrace() ;
		}
		return new NodeName(id) ;
		
//		if (id == null) throw new IllegalArgumentException("smallAlphaNumUnderbar, minLengt:" + minLength + ", maxLength:" + maxLength) ;
//		if (id.length() > maxLength || id.length() < minLength) throw new IllegalArgumentException("smallAlphaNumUnderbar, minLengt:" + minLength + ", maxLength:" + maxLength) ;
//
//		if (StringUtil.isAlphanumericUnderbarDash(id)) {
//			return new NodeName(id) ;
//		}
//		throw new IllegalArgumentException(id + " smallAlphaNumUnderbar, minLengt:" + minLength + ", maxLength:" + maxLength) ;
	}
	
	public static NodeName nodeName(String str) throws IllegalNodeNameException{
		return create(str, 1, 80) ;
	}
	
	
	public String getString() {
		return name;
	}
	
	public String toString(){
		return getString() ;
	}

}
