package com.bleujin.lore.core.nodetype;

import com.bleujin.lore.core.exception.NoSuchPropertyDefinitionException;
import com.bleujin.lore.core.mapping.IDefaultValue;
import com.bleujin.lore.core.mapping.IValueConstraint;
import com.bleujin.lore.core.node.Property;

public interface NewNodeType extends NodeTypeDefinition{

	public void addPropertyDefinition(String propName, Property.Type requireType) ;
	public void addPropertyDefinition(String propName, Property.Type requireType, IValueConstraint constraint, IDefaultValue defaultValue) throws NoSuchPropertyDefinitionException ;
	public void addPropertyDefinition(PropertyDefinition[] pds) ;
	
	public void setConstraint(PropertyDefinition prop, IValueConstraint constraint) throws NoSuchPropertyDefinitionException ;
	public void setDefaultValue(PropertyDefinition prop, IDefaultValue defaultValue)  throws NoSuchPropertyDefinitionException;
	public void setConstraint(String propName, IValueConstraint constraint) throws NoSuchPropertyDefinitionException ;
	public void setDefaultValue(String propName, IDefaultValue defaultValue)  throws NoSuchPropertyDefinitionException;
	
	public void setPrimary(PropertyDefinition pd) throws NoSuchPropertyDefinitionException ;
	public void setPrimary(String propName) throws NoSuchPropertyDefinitionException ;
	
	public void setMemberType(NodeType memberType) ;
	public void setSelfMemberType() ;

}

