package com.bleujin.lore.core.nodetype;

import com.bleujin.lore.core.TestCaseParent;
import com.bleujin.lore.core.dimpl.NodeTypeIdImpl;
import com.bleujin.lore.core.exception.NamespaceException;
import com.bleujin.lore.core.persitence.NamespaceRegistry;

public class TestNodeTypeId extends TestCaseParent{

	
	public void testSimple() throws Exception {
		NamespaceRegistry namespace = session.getNodeTypeManager().getNamespace();

		NodeTypeId p1 = NodeTypeIdImpl.create(namespace, "person") ;
		assertEquals("default:person", p1.getString()) ;
		
		NodeTypeId p2 = NodeTypeIdImpl.create(namespace, "default:person") ;
		assertEquals("default:person", p2.getString()) ;
		
		assertEquals(p1, p2) ;

		NodeTypeId p3 = NodeTypeIdImpl.create(namespace, "default:PERSON") ;
		assertEquals("default:person", p3.getString()) ;


		assertEquals(p3, p2) ;
	}

	
	
	public void testWrongNamespace() throws Exception {
		NamespaceRegistry namespace = session.getNodeTypeManager().getNamespace();

		try {
			NodeTypeId ntId = NodeTypeIdImpl.create(namespace, "Default:person") ;
			fail() ;
		} catch(NamespaceException ignore){}
		
	}
}
