package com.bleujin.lore.core.observation;

import java.util.Stack;
import java.util.logging.Level;
import java.util.logging.Logger;

import com.bleujin.framework.logging.LogBroker;

public class EventStackingListener implements EventListener{

	private Stack<Event> store = new Stack<Event>() ;
	private Logger log = LogBroker.getLogger(EventStackingListener.class) ;

	public final static int MAX_MESSAGE = 2000 ;
	public EventStackingListener(){
		
	}
	
	public boolean isDealWith(Event nodeEvent) {
	    return true;
    }

	public void onEvent(Event event) {
        if (getCount() > (MAX_MESSAGE /2) ){
            log.log(Level.WARNING, "Warning.. reach at the half of stack size.. if any exeption not exists, consider to increase stack's max size");
            log.log(Level.WARNING, "event : " + event) ;
        }
	    store.push(event) ;
    }
	
	Event popEvent(){
		return store.pop() ;
	}
	
	void clearStack(){
		store.clear() ;
	}
	
	int getCount(){
		return store.size() ;
	}

}
