package com.bleujin.lore.core.observation;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;

import org.apache.commons.io.IOUtils;

import com.bleujin.framework.util.DateUtil;
import com.bleujin.framework.util.PathMaker;
import com.bleujin.lore.core.exception.ALRepositoryRuntimeException;

public class FileListener implements EventListener {

	
	private File file ;
	private String originalName ;
	private long MAX_SIZE = 1024L * 1024 * 5 ; // 5M
	public FileListener(File file){
		this.file = file ;
		if (! file.getParentFile().exists()) file.getParentFile().mkdirs() ;
		this.originalName = file.getName() ;
	}
	
	public void onEvent(Event event) {
		String message = DateUtil.currentSeoulToString() + ", " + event.toString() + "\n";
		try {
			if (file.length() > MAX_SIZE) {
				changeNextFile() ;
			}
			
			FileOutputStream output = new FileOutputStream(file, true);
			IOUtils.write(message, output, "UTF-8") ;
			output.close() ;
			
		} catch (FileNotFoundException e) {
			throw new ALRepositoryRuntimeException(e) ;
		} catch (IOException e) {
			throw new ALRepositoryRuntimeException(e) ;
		}
    }

	public boolean isDealWith(Event nodeEvent) {
	    return true;
    }
	
	private static int index = 0 ;
	private void changeNextFile(){
		index = (++index >= 5) ? (index % 5) : index ;
		File nextFile = new File(PathMaker.getFilePath(file.getParent(), originalName + (index == 0 ? "" : String.valueOf(index)))) ;
		if(nextFile.exists() && nextFile.length() > MAX_SIZE) nextFile.delete() ;
		this.file = nextFile;
	}
	
}