package com.bleujin.lore.core.observation;

import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.link.Link;

public class LinkEvent extends Event {

	private Link link;
	public LinkEvent(Link link, EventType eventType, UserBean userInfo) {
		super(userInfo, eventType) ;
		this.link = link;
    }

	public Link getLink() throws ALRepositoryException{
		return this.link ;
	}
	
	public String toString(){
		return link.toString() + ", " + getType() ;
	}
	
	public boolean equals(Object obj){
		if (this == obj) return true ;
		if (obj == null || !(obj instanceof LinkEvent)) return false ;
		LinkEvent that = (LinkEvent)obj ;
		
		return (this.link.equals(that.link)  && this.getType().equals(that.getType()) && this.getTriggerUser().equals(that.getTriggerUser())) ;
	}
	
	public int hashCode(){
		return 97 * this.link.hashCode() + 31 * getType().hashCode() + getTriggerUser().hashCode() ; 
	}
}
