package com.bleujin.lore.core.persitence ;

import java.util.Collections;
import java.util.Map;

import org.apache.commons.collections.BidiMap;
import org.apache.commons.collections.bidimap.DualHashBidiMap;

import com.bleujin.lore.core.exception.NamespaceException;

// central..
// starti with ('_')  nodetype

public class NamespaceCentral {
	private BidiMap store = new DualHashBidiMap() ;
	private final static NamespaceCentral SELF = new NamespaceCentral() ;
	private final static boolean SUEECESS = true ;

	private NamespaceCentral(){
		store.put("_default", new URI("_default", "www.bleujin.com")) ;
		store.put("_system", new URI("_system", "www.bleujin.com")) ;
	}
	public static NamespaceCentral getInstance() {
	    return SELF;
    }

    public Map getNamespaces() {
        return Collections.unmodifiableMap(store);
    }
    
    public boolean add(String prefix, String uri) throws NamespaceException{
    	if (store.containsKey(prefix)) throw new NamespaceException(prefix + " already exist..") ;
    	store.put(prefix, uri) ;
    	return SUEECESS ;
    }

    public boolean remove(String prefix){
    	store.remove(prefix) ;
    	return SUEECESS ;
    }

    public boolean isContains(String prefix){
    	return getURI(prefix) != null ;
    }
    
    public URI getURI(String prefix){
        return (URI)store.get(prefix);
    }

}