package com.bleujin.lore.core.persitence;

import java.io.Serializable;

import com.bleujin.framework.util.StringUtil;
import com.bleujin.lore.core.common.GenericIterator;
import com.bleujin.lore.core.dimpl.AbstractGlobalStore;
import com.bleujin.lore.core.exception.NamespaceException;

public class NamespaceRegistry implements Serializable{

	private static final long serialVersionUID = 1001307266524633969L;
	private GlobalStore astore ;
    public NamespaceRegistry(AbstractGlobalStore astore) {
    	this.astore = astore ;
    }

	public boolean add(String prefix, String address) throws NamespaceException {
		
		if ((!StringUtil.isSmallAlphaNumUnderBar(prefix)) || prefix.startsWith("_")) 
			throw new NamespaceException("prefix must be smallAlphaNumUnderBar and cant start with '_'") ;

		if ("default".equals(prefix)) return false;
		
		int result = astore.addURIAddress(prefix, address) ;
		return result > 0 ; 
    }

	public void remove(String prefix) {
		astore.removeURIAddress(prefix) ;
	}

    public GenericIterator<URI> listURI() {
        return astore.listURIAddress() ; 
    }

    public boolean isContainPrefix(String prefix) throws NamespaceException{
    	return "default".equals(prefix) || astore.existURIAddress(prefix) ;
    }
    
    public URI getURI(String prefix) throws NamespaceException{
    	if (prefix.startsWith("_")) {
    		return getNamespaceCentral().getURI(prefix) ;
    	}
    	
    	if ("default".equals(prefix)) return new URI("default", "localhost") ;
    	return astore.getURIAddress(prefix) ;

    }

	private NamespaceCentral getNamespaceCentral() {
	    return NamespaceCentral.getInstance();
    }

}
