package com.bleujin.lore.core.persitence;

import java.io.Serializable;

import com.bleujin.lore.core.bean.Rating;
import com.bleujin.lore.core.bean.Register;
import com.bleujin.lore.core.bean.SourceFrom;
import com.bleujin.lore.core.common.Publishable;
import com.bleujin.lore.core.node.NodeName;
import com.bleujin.lore.core.nodetype.NodeTypeId;

public interface NodeBean extends Publishable, Serializable{

	public final static String XML_TAG_ROOT = "node-info" ;
	public final static String XML_TAG_NAME = "name" ;
	public final static String XML_TAG_EXPLAIN = "explain" ;
	public final static String XML_TAG_UUID = "uuid" ;
	public final static String XML_TAG_REGISTER = "register" ;
	public final static String XML_TAG_VISIT = "visit" ;
	
	
	public void setName(NodeName name) ; 
	
	public NodeName getName() ;

	public void setExplain(String explain) ;

	public String getExplain() ;

	public String getIdentifier() ;

	public long getViewCount() ;
	
	public void setRegister(Register register) ;

	public Register getRegister() ;
	
	public void setSourceFrom(SourceFrom from) ;
	
	public SourceFrom getSourceFrom() ;
	
	public void addRating(Rating rating) ;
	
	public NodeTypeId getNodeTypeId() ;

	public String getStatus() ;

	public String getWorkspaceName();

	public void increaseViewCount();
	
	public NodeBean newClone() ;

}
