package com.bleujin.lore.core.search;

import java.util.Date;

import org.apache.commons.lang.StringUtils;
import org.apache.lucene.document.Field;

public class NewField {

	// pre : keyId is not null
	public final static Field keywordField(String keyId, long value) {
		return keywordField(getKey(keyId), getValue(value));
	}

	public final static Field keywordField(String keyId, Date value) {
		return keywordField(getKey(keyId), getValue(value));
	}

	public final static Field textField(String keyid, String value) {
		return new Field(getKey(keyid), getValue(value), Field.Store.YES, Field.Index.TOKENIZED);
	}

	public final static Field unStoredField(String keyid, String value) {
		return new Field(getKey(keyid), getValue(value), Field.Store.NO, Field.Index.TOKENIZED);
	}

	public final static Field keywordField(String keyid, String value) {
		return new Field(getKey(keyid), getValue(value), Field.Store.YES, Field.Index.UN_TOKENIZED);
	}

	private static String getKey(String keyId) {
		// assert : key is not null
		return keyId.toLowerCase();
	}

	public final static int NUMBER_PAD_SIZE = 12;

	public static String getValue(int value) {
		return StringUtils.leftPad(String.valueOf(value), NUMBER_PAD_SIZE, '0');
	}

	private static String getValue(Object value) {
		if (value == null || value.toString() == null)
			return StringUtils.EMPTY;
		else
			return value.toString();
	}

}