package com.bleujin.lore.core.search.document;

import java.io.InputStream;

import javax.swing.text.DefaultStyledDocument;
import javax.swing.text.rtf.RTFEditorKit;

import org.apache.commons.lang.StringUtils;
import org.apache.lucene.document.Document;

import com.bleujin.lore.core.exception.DocumentHandlerException;
import com.bleujin.lore.core.search.NewField;

public class RTFHandler implements DocumentHandler {
	public RTFHandler() {
	}

	public Document getDocument(InputStream is) throws DocumentHandlerException {

		String bodyText = "";
		DefaultStyledDocument sdoc = new DefaultStyledDocument();
		try {
			new RTFEditorKit().read(is, sdoc, 0);
			bodyText = sdoc.getText(0, sdoc.getLength());
		} catch (Exception ex) {
			throw new DocumentHandlerException("cannot parse RTF Document", ex);
		}

		if (StringUtils.isNotBlank(bodyText)) {
			Document doc = new Document();
			doc.add(NewField.unStoredField(BODY, bodyText));
			return doc;
		}

		return null;
	}

}
