package com.bleujin.lore.core.search.document;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.apache.commons.lang.StringUtils;
import org.apache.lucene.document.Document;

import com.bleujin.lore.core.exception.DocumentHandlerException;
import com.bleujin.lore.core.search.NewField;

public class TextHandler implements DocumentHandler {
	public TextHandler() {
	}

	public Document getDocument(InputStream is) throws DocumentHandlerException {
		String bodyText = "";

		try {
			BufferedReader reader = new BufferedReader(new InputStreamReader(is));
			String line = null;
			while ((line = reader.readLine()) != null) {
				bodyText += line;
			}
			reader.close();
		} catch (IOException ex) {
			throw new DocumentHandlerException("cannot reade the text document", ex);
		}

		if (StringUtils.isNotBlank(bodyText)) {
			Document doc = new Document();
			doc.add(NewField.unStoredField(BODY, bodyText));
			return doc;
		}

		return null;
	}

}
