package com.bleujin.lore.core.search.document;

import java.io.InputStream;
import java.util.HashMap;
import java.util.Iterator;

import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;

import org.apache.lucene.document.Document;
import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import com.bleujin.lore.core.exception.DocumentHandlerException;
import com.bleujin.lore.core.search.NewField;

public class XMLHandler extends DefaultHandler implements DocumentHandler {

	private StringBuffer elementBuffer = new StringBuffer();
	private HashMap attributeMap = new HashMap();
	private Document doc;

	public XMLHandler() {
	}

	public Document getDocument(InputStream is) throws DocumentHandlerException {
		SAXParserFactory spf = SAXParserFactory.newInstance();
		try {
			SAXParser parser = spf.newSAXParser();
			parser.parse(is, this);
		} catch (Exception ex) {
			throw new DocumentHandlerException("Cannot parse XMLDocument", ex);
		}

		return doc;
	}

	public void startDocument() {
		doc = new Document();
	}

	public void startElement(String uri, String localName, String qName, Attributes attr) throws SAXException {
		elementBuffer.setLength(0);
		attributeMap.clear();

		if (attr.getLength() > 0) {
			attributeMap = new HashMap();
			for (int i = 0, last = attr.getLength(); i < last; i++) {
				attributeMap.put(attr.getQName(i), attr.getValue(i));
			}
		}
	}

	public void characters(char[] text, int start, int length) {
		elementBuffer.append(text, start, length);
	}

	public void endElement(String uri, String localName, String qName) throws SAXException {
		if ("node".equals(qName)) {
			return;
		} else if ("property".equals(qName)) {
			Iterator iter = attributeMap.keySet().iterator();
			while (iter.hasNext()) {
				String attName = (String) iter.next();
				String attValue = (String) attributeMap.get(attName);
				doc.add(NewField.unStoredField(attName, attValue));
			}
		} else {
			doc.add(NewField.unStoredField(qName, elementBuffer.toString()));
		}

	}

}
