package com.bleujin.lore.core.search.indexer;

import java.sql.SQLException;

import com.bleujin.framework.db.manager.DBManager;
import com.bleujin.framework.db.procedure.UserProcedure;

public class CancelLog {

    public final static EmptyCancel EMPTY = new EmptyCancel(null, null) ;
    private DBManager dbm ;
    private UserProcedure upt ;
    public CancelLog(DBManager dbm, UserProcedure upt) {
        this.dbm = dbm ;
        this.upt = upt ;
    }

    public void cancel(){
        try {
            upt.execUpdate(dbm);
        } catch(SQLException ex) {
            ex.printStackTrace();
        }
    }

}

class EmptyCancel extends CancelLog {

    EmptyCancel(DBManager dbm, UserProcedure upt){
        super(dbm, upt) ;
    }

    public void cancel() {
        ; // no action
    }

}