package com.bleujin.lore.core.search.indexer;

import java.io.IOException;

import org.apache.lucene.index.IndexWriter;
import org.apache.lucene.store.Directory;

import com.bleujin.lore.core.common.lock.ReadsWriteLock;

public class ClusteredReadsWriteLock implements ReadsWriteLock {

    private Directory dir ;
    public ClusteredReadsWriteLock(Directory dir) {
        this.dir = dir ;
    }

    public synchronized void readLock() throws InterruptedException{
        try {
            lock(dir);
        } catch(IOException ex) {
            ex.printStackTrace();
        }
    }

    public synchronized void readUnLock() {
        unlock();
    }

    public synchronized void writeLock() throws InterruptedException {
        try {
            lock(dir);
        } catch(IOException ex) {
            ex.printStackTrace();
        }
    }

    public synchronized void writeUnLock() {
        unlock();
    }


    private Thread owner = null ;
    private void lock(Directory dir) throws IOException, InterruptedException{
        Thread me = Thread.currentThread() ;
        while(owner != me && IndexWriter.isLocked(dir)) {
            wait();
        }
        owner = me ;
    }

    private void unlock(){
        Thread me = Thread.currentThread() ;
        if (owner != me) return ;
        owner = null ;
        notifyAll();
    }

}
