package com.bleujin.lore.core.search.indexer;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang.StringUtils;
import org.apache.lucene.document.Document;
import org.apache.lucene.document.Field;

import com.bleujin.lore.core.search.NewField;

public class MyDocument {
    private Document doc ;
    private List fields = new ArrayList() ;

    public MyDocument() {
        this.doc = new Document() ;
    }

    public void addField(Field field){
        fields.add(field.stringValue());
        doc.add(field);
    }

    public void addKeyword(String keyId, long value){
        fields.add(String.valueOf(value));
        doc.add(keywordField(keyId, value));
    }

    public void addKeyword(String keyId, String value){
        fields.add(value);
        doc.add(keywordField(keyId, value));
    }

    public void addText(String keyId, String value){
        fields.add(value);
        doc.add(textField(keyId, value));
    }

    public void addUnstored(String keyId, String value){
        fields.add(value);
        doc.add(unStoredField(keyId, value));
    }

    Document getDocument() {
        doc.add(unStoredField(IndexerHelper.ALL_FIELD, StringUtils.join( (String[])fields.toArray(new String[0]), ", " ) ));

        return this.doc ;
    }




    // pre : keyId is not null
    private Field keywordField(String keyId, long value){
        return NewField.keywordField(keyId, value) ;
    }

    private Field textField(String keyId, String value){
        return NewField.textField(keyId, value) ;
    }

    private Field unStoredField(String keyId, String value){
        return NewField.unStoredField(keyId, value) ;
    }

    private Field keywordField(String keyId, String value){
        return NewField.keywordField(keyId, value) ;
    }


}
