package com.bleujin.lore.core.search.indexer;

import java.io.File;

import com.bleujin.lore.core.TestCaseParent;

public class TestCaseSearchParent extends TestCaseParent {

	public final static String TEST_INDEX_DIR = "C:/temp/index";
	public final static String TEST_FILE_DIR = "c:/temp/file";
	public final static String TEST_LOCK_DIR = "c:/temp/lock";

	static {
		System.setProperty("org.apache.lucene.lockDir", TEST_LOCK_DIR);
	}

	protected NodeIndexer mindexer = null;
	protected NodeIndexer findexer = null;

	public void setUp() throws Exception {
		super.setUp();
		mindexer = new NodeIndexer(IndexDirectory.createRamIndexDir());

		cleanFile(); // if fsDirectory
		findexer = new NodeIndexer(IndexDirectory.createIndexDirectory(TEST_INDEX_DIR));
	}

	private void cleanFile() {
		File indexDir = new File(TEST_INDEX_DIR);
		if (indexDir.exists()) {
			for (File file : indexDir.listFiles()) {
				file.delete();
			}
		}

		File lockDir = new File(TEST_LOCK_DIR);
		if (lockDir.exists()) {
			for (File file : lockDir.listFiles()) {
				file.delete();
			}
		}
	}

}
