package com.bleujin.lore.core.search.indexer;

import java.util.ArrayList;
import java.util.List;

import com.bleujin.lore.core.common.Page;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.search.searcher.NodeSearcher;
import com.bleujin.lore.core.search.searcher.SearchResult;

public class TestDefault extends TestCaseSearchParent{
	
	public void testIndexUpdate() throws Exception {
		
		List<Node> nodes = new ArrayList<Node>() ;
		Node n1 = saveNode(getRobotType(), "abc") ;
		String explain = "explain";
		
		n1.setProperty(explain, "abc") ;
		nodes.add(n1) ;
		
	    mindexer.add(nodes) ;
	    
	    n1.setProperty(explain, "def") ;
	    mindexer.update(nodes) ;
	    
	    
	    NodeSearcher searcher = new NodeSearcher(session, mindexer.getDirectory()) ;
	    
	    SearchResult sr = searcher.search("explain:def") ;
	    assertEquals(1, sr.totalLength()) ;

	    
	    n1.setProperty(explain, "ghi") ;
	    mindexer.update(nodes) ;

	    sr = searcher.search("explain:ghi") ;
	    assertEquals(1, sr.totalLength()) ;
	    
	    n1.save();
	    assertEquals("ghi", sr.toNode(Page.TEN).get(0).getString(explain));
    }

}
