package com.bleujin.lore.core.search.indexer;

import java.util.Map;

import org.apache.commons.lang.time.StopWatch;

import com.bleujin.lore.core.TestCaseParent;
import com.bleujin.lore.core.node.Node;

public class TestIndexer extends TestCaseParent {

	public void testIndexeInfo() throws Exception {
	    Map info = session.getLocalStore().getIndexer().getIndexInfo() ;
	    assertTrue((Integer)info.get("indexedfieldnum") >=  0) ;
    }
	
	public void testIndex() throws Exception {
		Node robot = saveNode(getRobotType(), "robot") ;
		robot.setProperty("explain", "R3") ;
		
		session.save() ;
		assertNotNull(session.getLocalStore().getIndexer().getIndexInfo()) ;
	    assertEquals(1, session.getLocalStore().getIndexer().getIndexInfo().get("numdoc")) ;
    }
	
	public void testIndexingSpeed() throws Exception {
	    // make 100 node indexing speed < 1 sec
		int count = 10 ;
		for (int i = 0, last = count-1; i < last; i++) {
			Node robot = saveNode(getRobotType(), "robot" + i) ;
			robot.setProperty("explain", "twin serial number:" + i ) ;
			
        }
		
		StopWatch watch = new StopWatch() ;
		watch.start() ;

		session.save() ;
		
		watch.stop() ;
		long time = watch.getTime();
		// Debug.debug(this, " : " + time) ;
		assertEquals(count + " indexing time : " + time , true, 1000 > time) ;
    }

}
