package com.bleujin.lore.core.search.limo;

import java.util.Map;
import java.util.Set;
import java.util.TreeMap;

// Referenced classes of package net.sourceforge.limo:
//            ReconstructedField

public class ReconstructedDocument {

    public ReconstructedDocument() {
        fieldValueMap = new TreeMap();
    }

    public void add(String name, String value) {
        add(name, value, 0, true);
    }

    public void add(String name, String value, int position, boolean stored) {
        if (!fieldValueMap.containsKey(name)) {
            ReconstructedField field = new ReconstructedField(name, stored);
            field.addValue(value, position);
            fieldValueMap.put(name, field);
            return;
        } else {
            ReconstructedField field = (ReconstructedField) fieldValueMap.get(name);
            field.addValue(value, position);
            return;
        }
    }

    public Set getFields() {
        return fieldValueMap.keySet();
    }

    public String getValue(String field) {
        return ( (ReconstructedField) fieldValueMap.get(field)).getValue();
    }

    public boolean contains(String field) {
        return fieldValueMap.containsKey(field);
    }

    public boolean isStored(String fieldName) {
        ReconstructedField field = (ReconstructedField) fieldValueMap.get(fieldName);
        if (field == null)
            return false;
        else
            return field.isStored();
    }

    public boolean isReconstructed(String fieldName) {
        return!isStored(fieldName);
    }

    private Map fieldValueMap;
}
