package com.bleujin.lore.core.security;

import com.bleujin.lore.addon.security.IResource;
import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.node.Node;

public class NodeResource implements IResource {

	private Node node ;
	//public final static NodeResource NO_PARENT = new NodeResource(Node.NO_PARENT) ;
	public NodeResource(Node node) {
	    this.node = node ;
    }
	public IResource getParent() throws ALRepositoryException {
		if (node.getParent().isRoot() == false){
			return new NodeResource(node.getParent()) ;
		}
	    return new NodeResource(node.getSession().getRootNode());
    }
	public String getKey() throws ALRepositoryException {
	    return node.getPath();
    }
	
	public boolean equals(Object o){
		if (o instanceof NodeResource){
			return this.node.isSame( ((NodeResource)o).node ) ;
		} 
		return false ;
	}
	
	public int hashCode(){
		return node.getIdentifier().hashCode() ;
	}

	public String toString(){
		return node.getName() ;
	}
	
	public boolean isRoot() throws ALRepositoryException {
		return node.isRoot();
	}
	
}
