package com.bleujin.lore.core.session;

import java.io.Serializable;

public abstract class AbstractSession implements Session, Serializable {
	/**
	 * @param time
	 *            session이 생성된 시각
	 */
	public abstract void setCreationTime(long time);

	/**
	 * @param id
	 *            session의 id
	 */
	public abstract void setId(String id);

	/**
	 * 마지막으로 접근한 시각. '접근' attribute에 대한 모든 get,set...을 의미한다.
	 * 
	 * @param time
	 */
	public abstract void setLastAccessedTime(long time);

	/**
	 * @param context
	 *            session이 사용하는 context
	 */
	public abstract void setSessionContext(SessionContext context);

	/**
	 * @param interval
	 *            session이 inactive 상태로 valid한 시간(초)
	 */
	public abstract void setMaxInactiveInterval(int interval);

	/**
	 * 새로 생성된 session인지 여부
	 * 
	 * @param isNew
	 */
	public abstract void setNew(boolean isNew);
}