package com.bleujin.lore.core.session;

/**
 * @author bleujin@gmail.com
 * @version 1.0
 * 
 * @see com.bleujin.lore.core.session.SessionManager
 */
public class SimpleSessionManager extends SessionManager {
	private String name;

	protected SimpleSessionManager(String name) {
		this.name = name;
		this.setSessionContext(new SimpleSessionContext());
	}

	protected AbstractSession createSession(String sessionId) {
		SimpleSession session = new SimpleSession(getSessionContext(), sessionId, getMaxInactiveInterval());

		getSessionContext().add(session);
		return session;
	}

	public String getInfo() {
		return this.getClass().getName();
	}

	public String getName() {
		return this.name;
	}

	protected void load() {
	}

	protected void unload() {
	}
}
