package com.bleujin.lore.core.util;

import java.util.Enumeration;
import java.util.HashMap;

import net.sf.json.JSONObject;

import org.apache.ecs.GenericElement;
import org.apache.ecs.xml.XML;

import com.bleujin.framework.util.StringUtil;
import com.bleujin.lore.core.exception.JSONExeption;


public class JSONUtil {
	public static JSONObject toJSON(XML xml) throws JSONExeption{
		return make(xml) ;
	}
	

	private static JSONObject make(XML xml) throws JSONExeption {
		HashMap<String, Object> root = new HashMap<String, Object>();
		makeJSON(null, root, xml);
		JSONWriter writer = new JSONWriter();

		return JSONObject.fromString(writer.write(root));
	}

	public static void makeJSON(HashMap<String, Object> parent, HashMap<String, Object> map, XML xml) {
		Enumeration els = xml.elements();
		while (els.hasMoreElements()) {
			GenericElement element = (GenericElement) els.nextElement();

			if (StringUtil.isBlank(element.getElementType())) {
				if (parent == null) return ;
				parent.put(xml.getElementType(), element.toString() ) ;
			} else {
				XML newElement = (XML) element;
				HashMap<String, Object> newMap = new HashMap<String, Object>();
				map.put(newElement.getElementType(), newMap);
				makeJSON(map, newMap, newElement);
			}
		}
		Enumeration attrs = xml.attributes() ;
		while (attrs.hasMoreElements()) {
			String nextElement = "" + attrs.nextElement().toString();
			map.put(nextElement, xml.getAttribute(nextElement)) ;
			
//			Debug.debug(this, nextElement + " : " + xml.getAttribute(nextElement)) ;
		}

	}	
}
