package com.bleujin.lore.core.util;

import java.util.HashMap;
import java.util.Map;

import net.sf.json.JSONObject;

import org.apache.ecs.xml.XML;

import com.bleujin.lore.core.TestCaseParent;

public class TestJSON extends TestCaseParent {

	public void testWriter() throws Exception {
		Map<String, String> map = new HashMap<String, String>();
		map.put("aaa", "111");
		map.put("bbb", "222");
		map.put("ccc", "333");

		JSONWriter writer = new JSONWriter();
		// assertEquals(writer.write(map), {"ccc":"333","aaa":"111","bbb":"222"}) ;
		JSONObject js1 = JSONObject.fromString(writer.write(map));
		assertEquals("111", js1.get("aaa"));
		assertEquals("222", js1.get("bbb"));

		Map<String, Object> outerMap = new HashMap<String, Object>();
		outerMap.put("out1", "ddddd ");
		outerMap.put("out2", map);
		js1 = JSONObject.fromString(writer.write(outerMap));
		assertEquals("333", js1.getJSONObject("out2").get("ccc"));

	}

	public void testGrandChild() throws Exception {
		XML xml = new XML("root");
		XML child = new XML("child1");

		XML grandchild = new XML("grandchild");
		grandchild.addElement("grandchild value");

		child.addElement(grandchild);
		xml.addElement(child);

		JSONObject json = JSONUtil.toJSON(xml);
		
		assertEquals("grandchild value", json.getJSONObject("child1").get("grandchild")) ;
	}

}
