package com.bleujin.lore.core.valid;

import java.util.ArrayList;
import java.util.List;

import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.node.Node;

public class ValidChain {

	public final static ValidChain EMPTY = new ValidChain(new PreValidation[0]) ; 
	private List<PreValidation> list = new ArrayList<PreValidation>() ;
	
	public ValidChain(PreValidation preValid){
		this(new PreValidation[]{preValid}) ;
	}
	
	public ValidChain(PreValidation[] preValid){
		for (int i = 0, last = preValid.length; i < last; i++) {
			list.add(preValid[i]) ;
        }
	}
	
	public void addValidation(PreValidation preValid){
		list.add(preValid) ;
	}
	
	public boolean isValid(Node node) throws ALRepositoryException{
		for (int i = 0, last = list.size(); i < last; i++) {
			if (! list.get(i).isValid(node)) return false ;
        }
		return true ;
	}
	
}
