package com.bleujin.lore.core.value;

import java.io.IOException;
import java.io.InputStream;
import java.math.BigDecimal;
import java.util.Calendar;
import java.util.Map;

import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.exception.ValueFormatException;
import com.bleujin.lore.core.node.BinaryPropertyValue;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.node.Property;

public class BinaryValue extends Value {
 
	private static final long serialVersionUID = 1422506647900802822L;
	private BinaryPropertyValue value ;
	public BinaryValue(BinaryPropertyValue value) {
		this.value = value ;
	}
	

	public String getString() {
		if (value == null) return null ;
		return value.getName(); 
	}
	
	public String getValueString() {
		if (value == null) return null ;
		return value.toXML().toString() ;
	}

	public Object getObject(Map param, Node node) throws ALRepositoryException {
		return value ;
	}
	
	public InputStream getStream() throws IOException {
		return value.getInputStream() ;
	}

	public long getLong() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public BigDecimal getDecimal() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public double getDouble() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public Calendar getDate() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public boolean getBoolean() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public Property.Type getPropertyType() {
		return Property.Type.BINARY;
	}
	
	public Value newClone() {
		return new BinaryValue(value==null ? null : BinaryPropertyValue.toBinaryValue(value.toXML().toString()));
	}

	public long getLength(){
		return value.getSize() ;
	}
}
