package com.bleujin.lore.core.value;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectOutputStream;
import java.math.BigDecimal;
import java.util.Calendar;
import java.util.Map;

import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.exception.ValueFormatException;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.node.Property;

public class BooleanValue extends Value {
 
	private static final long serialVersionUID = 5218374116639077286L;
	private boolean value ;
	public BooleanValue(boolean value) {
		this.value = value ;
	}

	public String getString() {
		return getValueString();
	}
	
	public String getValueString() {
		return String.valueOf(value) ;
	}

	public Object getObject(Map param, Node node) throws ALRepositoryException {
		return getBoolean();
	}
	
	public InputStream getStream() throws IOException {
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		ObjectOutputStream oos = new ObjectOutputStream(baos);
		oos.write(getString().getBytes("UTF-8"));
		oos.flush();
		return new ByteArrayInputStream(baos.toByteArray());
	}

	public long getLong() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public BigDecimal getDecimal() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public double getDouble() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public Calendar getDate() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public boolean getBoolean() {
		return value ? Boolean.TRUE : Boolean.FALSE;
	}

	public Property.Type getPropertyType() {
		return Property.Type.BOOLEAN;
	}
	
	public Value newClone() {
		return new BooleanValue(this.value);
	}

}
