package com.bleujin.lore.core.value;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectOutputStream;
import java.math.BigDecimal;
import java.util.Calendar;
import java.util.Map;

import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.exception.ValueFormatException;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.node.Property;

public class DoubleValue extends Value {
 
	private static final long serialVersionUID = -5557836961468412543L;
	private double value ;
	public DoubleValue(double value) {
		this.value = value ;
	}

	

	public String getString() {
		return getValueString(); 
	}
	
	public String getValueString() {
		return new Double(value).toString() ; 
	}

	public Object getObject(Map param, Node node) throws ALRepositoryException {
		return value ;
	}
	
	public InputStream getStream() throws IOException {
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		ObjectOutputStream oos = new ObjectOutputStream(baos);
		oos.writeObject(getString().getBytes("UTF-8"));
		oos.flush();
		return new ByteArrayInputStream(baos.toByteArray());
	}

	public long getLong() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public BigDecimal getDecimal() throws ValueFormatException {
		return new BigDecimal(value) ;
	}

	public double getDouble() throws ValueFormatException {
		return value ;
	}

	public Calendar getDate() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public boolean getBoolean() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	
	
	public Property.Type getPropertyType() {
		return Property.Type.DOUBLE;
	}
	
	public Value newClone() {
		return new DoubleValue(value);
	}
}
