package com.bleujin.lore.core.value;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectOutputStream;
import java.math.BigDecimal;
import java.util.Calendar;
import java.util.Map;

import com.bleujin.lore.core.dimpl.AbstractNode;
import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.exception.ValueFormatException;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.node.Property;


public class ReferenceValue extends Value {
 
	private static final long serialVersionUID = 6184319743633390326L;
	
	private String identifier ;
	public ReferenceValue(Node node) {
		this(node== null ? null : node.getIdentifier()) ;
	}

	private ReferenceValue(String identifier){
		this.identifier = identifier ;
	}
	
	public String getString() {
		return getValueString(); 
	}
	
	public String getValueString() {
		return identifier ; 
	}

	public Object getObject(Map param, Node node) throws ALRepositoryException {
		return node.getNode(AbstractNode.ID_BEGIN_MARK + identifier + AbstractNode.ID_END_MARK) ;
	}
	
	public InputStream getStream() throws IOException {
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		ObjectOutputStream oos = new ObjectOutputStream(baos);
		oos.writeObject(getString().getBytes("UTF-8"));
		oos.flush();
		return new ByteArrayInputStream(baos.toByteArray());
	}

	public long getLong() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public BigDecimal getDecimal() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public double getDouble() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public Calendar getDate() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public boolean getBoolean() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public Property.Type getPropertyType() {
		return Property.Type.REFERENCE;
	}
	
	public Value newClone(){
		return new ReferenceValue(identifier);
	}
}
