package com.bleujin.lore.core.value;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectOutputStream;
import java.io.StringWriter;
import java.math.BigDecimal;
import java.util.Calendar;
import java.util.Map;

import org.apache.velocity.VelocityContext;
import org.apache.velocity.app.VelocityEngine;

import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.exception.ValueFormatException;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.node.Property;

public class VirtualTextValue extends Value {
 
	private static final long serialVersionUID = -5819124907497438600L;
	private String value ;
	public VirtualTextValue(String svalue) {
		this.value = svalue ;
	}


	public String getString() {
		return value; 
	}
	
	public String getValueString() {
		return value ; 
	}

	public Object getObject(Map param, Node node) throws ALRepositoryException {
		return getTransString(param, node) ;
	}
	
	public InputStream getStream() throws IOException {
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		ObjectOutputStream oos = new ObjectOutputStream(baos);
		oos.writeObject(getString().getBytes("UTF-8"));
		oos.flush();
		return new ByteArrayInputStream(baos.toByteArray());
	}

	public long getLong() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public BigDecimal getDecimal() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public double getDouble() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public Calendar getDate() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	public boolean getBoolean() throws ValueFormatException {
		throw new ValueFormatException() ;
	}

	
	
	public Property.Type getPropertyType() {
		return Property.Type.VIRTUAL_TEXT;
	}
	
	public Value newClone(){
		return new VirtualTextValue(value);
	}
	
	private String getTransString(Map param, Node node) throws ALRepositoryException {
		try {
			VelocityContext context = new VelocityContext();
			context.put("node", node);
			context.put("param", param);

			VelocityEngine engine = new VelocityEngine();
			engine.init();

			StringWriter writer = new StringWriter();
			engine.evaluate(context, writer, "logName", value);
			return writer.toString();

		} catch (Exception e) {
			throw new ALRepositoryException(e.getMessage());
		}
	}

}
