package com.bleujin.lore.core.workspace;

import java.util.List;
import java.util.Vector;

import com.bleujin.lore.core.common.GenericIterator;
import com.bleujin.lore.core.common.GenericIteratorHelper;
import com.bleujin.lore.core.observation.Event;
import com.bleujin.lore.core.observation.EventListener;

public class ObservationManager {

	public static final ObservationManager EMPTY = new ObservationManager();
	
	private List<EventListener> store = new Vector<EventListener>();

	ObservationManager(){
	}
	
	public void addEventListener(EventListener listener) {
		store.add(listener);
	}

	public void removeEventListener(EventListener listener) {
		store.remove(listener);
	}

	public GenericIterator<EventListener> getListener(){
		return new GenericIteratorHelper<EventListener>(store) ;
	}

	public void fireEvent(Event event) {
		
		for (EventListener listener : store) {
			if (listener.isDealWith(event)) {
				listener.onEvent(event);
			}
        }
	}

}
