package com.bleujin.lore.core.workspace;

import junit.framework.TestCase;

import com.bleujin.lore.core.dimpl.NodeTypeManager;
import com.bleujin.lore.core.dimpl.UserSession;
import com.bleujin.lore.core.node.NodeName;
import com.bleujin.lore.core.nodetype.NewNodeType;
import com.bleujin.lore.core.nodetype.NodeType;
import com.bleujin.lore.core.nodetype.PropertyDefinition;
import com.bleujin.lore.core.workspace.config.InitLore;

public class TestInitialize extends TestCase {
	
	private String configFileName = "D:/eclipse/workspace/anotherLore/webapps/board/WEB-INF/anotherlore-config.xml";
	public void testCreateAnotherLore() throws Exception {
		AnotherLore lore = InitLore.init() ;
	}
	
	public void testWorkspaceCreate() throws Exception {
		AnotherLore anotherLore = InitLore.init() ;
		
		UserSession session = anotherLore.login(new TestCredential("bleujin"));
		Workspace workspace = session.getWorkspace() ;
		workspace.clearStore() ;
		NodeTypeManager ntManater = session.getNodeTypeManager() ;
		
		NewNodeType newType = ntManater.createNodeTypeTemplate(NodeType.NO_SUPERTYPE, "_object", new PropertyDefinition[0]);
		NodeType objectType = ntManater.register(newType, false) ;
		session.createNode(session.getRootNode(), objectType, NodeName.ROOT_NAME, "");
		session.save();
		
		anotherLore.destroyWorld() ;
	}
	

	
	public void testConfigFile() throws Exception {
		AnotherLore anotherLore = InitLore.init(configFileName) ;
	}

}
