package com.bleujin.lore.core.workspace;

import com.bleujin.lore.core.TestCaseParent;
import com.bleujin.lore.core.dimpl.PropertyDefinitionImpl;
import com.bleujin.lore.core.dimpl.UserSession;
import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.exception.NamespaceException;
import com.bleujin.lore.core.nodetype.NodeType;
import com.bleujin.lore.core.persitence.NamespaceRegistry;
import com.bleujin.lore.core.persitence.URI;

public class TestNamespace extends TestCaseParent {

	public void testNameSpaceCentral() throws Exception {
	    UserSession bleujin = anotherLore.login(new TestCredential("bleujin")) ;
	    
		// String[] prefixs = bleujin.getNamespacePrefixes() ;
    }
	
	public void testNamespace() throws Exception {
	    NamespaceRegistry ns = session.getNodeTypeManager().getNamespace() ;
	    assertEquals("www.bleujin.com", ns.getURI("_default").getAddress()) ;
	    
	    assertEquals("localhost", ns.getURI("default").getAddress()) ;
    }
	
	public void testPrefix() throws Exception {
	    NamespaceRegistry ns = session.getNodeTypeManager().getNamespace() ;
		ns.add("insa", "com.bleujin.www") ;
		
		URI insa = ns.getURI("insa") ;
		assertEquals("com.bleujin.www", insa.getAddress()) ;

		assertEquals(false, ns.add("insa", "other")) ;
		
		try {
			ns.add("_insa", "com.bleujin.www") ;  // disallowed _ start
			fail() ;
		} catch(NamespaceException ignore){
		}
		
	}
	
	public void testNodeType() throws Exception {
		
		NodeType default_persion = registerNodeType(objectType, "person", new PropertyDefinitionImpl[]{}) ;
		try {
			registerNodeType(objectType, "person", new PropertyDefinitionImpl[]{}) ;
			fail();
		} catch(ALRepositoryException ignore){}
		
		NamespaceRegistry ns = session.getNodeTypeManager().getNamespace() ;
		ns.add("insa", "com.bleujin/insa") ;
		NodeType insa_persion = registerNodeType(objectType, "insa:person", new PropertyDefinitionImpl[]{}) ;
		
		assertEquals("default:person", default_persion.getName()) ;
		assertEquals("insa:person", insa_persion.getName()) ;
		
		try {
			createNewNodeType(objectType, "Insa:person", new PropertyDefinitionImpl[]{}) ;
			fail();
		} catch(ALRepositoryException ignore){}
		
	}
	
}
