package com.bleujin.lore.core.workspace;

import org.apache.commons.lang.time.StopWatch;

import com.bleujin.lore.core.TestCaseDB;
import com.bleujin.lore.core.common.IDString;
import com.bleujin.lore.core.dimpl.carrier.WorkspaceCarrier;

public class TestSequence extends TestCaseDB {

	private IDString abc = IDString.seqId("abc");
	public void testSequence() throws Exception {
		WorkspaceCarrier carrier = new WorkspaceCarrier(dc);

		carrier.reset(abc);
		long val = 0L ; 

		val = carrier.currVal(abc);
		assertEquals(0L, val);

		val = carrier.nextVal(abc);
		assertEquals(1L, val);

		val = carrier.nextVal(abc);
		assertEquals(2L, val);

		val = carrier.currVal(abc);
		assertEquals(2L, val);

	}
	
	public void testSpeed() throws Exception {
		WorkspaceCarrier carrier = new WorkspaceCarrier(dc);
		carrier.reset(abc); // start pooling
		long val = 1L ;

		StopWatch watch = new StopWatch() ;
		watch.start() ;

		for (int i = 0; i < 20; i++) {
			assertEquals(val++, carrier.nextVal(abc));
		}

		long time = watch.getTime() ;
		assertEquals(true, time < 200L) ;
		
	}
}
