package com.bleujin.lore.core.workspace.config;

import java.util.ArrayList;
import java.util.List;

import com.bleujin.framework.configuration.Configuration;
import com.bleujin.framework.configuration.ConfigurationException;

public class WorkspacesInfo {

	private List<WorkspaceInfo> store = new ArrayList<WorkspaceInfo>() ;

	private WorkspacesInfo(Configuration config) throws ConfigurationException {
	
		Configuration[] workspaces = config.getChildren("workspace") ;
		for (Configuration wconfig : workspaces) {
			String name = wconfig.getAttribute("name") ;
			String isDefault = wconfig.getAttribute("default", "false") ;
			String storage = wconfig.getChild("reference-storage").getValue() ;
			WorkspaceInfo winfo = new WorkspaceInfo(name, storage, Boolean.valueOf(isDefault).booleanValue());

			store.add(winfo) ;
		}
	}
	
	public List<WorkspaceInfo> getInfo(){
		return store ;
	}

	public final static WorkspacesInfo create(Configuration config) throws ConfigurationException {
		return new WorkspacesInfo(config);
	}
}

