/*
 * Copyright 2006 Day Management AG, Switzerland. All rights reserved.
 */
package com.bleujin.lore.extend.query;

import com.bleujin.lore.core.exception.ALRepositoryException;

/**
 * Thrown by methods of <code>Query</code>.
 * 
 */
public class InvalidQueryException extends ALRepositoryException {
	/**
	 * Constructs a new instance of this class with <code>null</code> as its
	 * detail message.
	 */
	public InvalidQueryException() {
		super();
	}

	/**
	 * Constructs a new instance of this class with the specified detail
	 * message.
	 * 
	 * @param message
	 *            the detail message. The detail message is saved for later
	 *            retrieval by the {@link #getMessage()} method.
	 */
	public InvalidQueryException(String message) {
		super(message);
	}

	/**
	 * Constructs a new instance of this class with the specified detail message
	 * and root cause.
	 * 
	 * @param message
	 *            the detail message. The detail message is saved for later
	 *            retrieval by the {@link #getMessage()} method.
	 * @param rootCause
	 *            root failure cause
	 */
	public InvalidQueryException(String message, Throwable rootCause) {
		super(message, rootCause);
	}

	/**
	 * Constructs a new instance of this class with the specified root cause.
	 * 
	 * @param rootCause
	 *            root failure cause
	 */
	public InvalidQueryException(Throwable rootCause) {
		super(rootCause);
	}
}
