/*
 * Copyright 2006 Day Management AG, Switzerland. All rights reserved.
 */
package com.bleujin.lore.extend.query;

import javax.jcr.RepositoryException;
import javax.jcr.query.InvalidQueryException;
import javax.jcr.query.qom.EquiJoinCondition;
import javax.jcr.query.qom.JoinCondition;
import javax.jcr.query.qom.QueryObjectModelConstants;

import com.bleujin.lore.core.dimpl.UserSession;
import com.bleujin.lore.core.nodetype.NodeType;

/**
 * A <code>QueryObjectModelFactory</code> creates instances of the JCR query
 * object model.
 * <p>
 * Refer to {@link QueryObjectModel} for a description of the query object
 * model.
 * 
 * @since JCR 2.0
 */
public class QueryObjectModelFactory implements QueryObjectModelConstants {

	private UserSession session ;
	QueryObjectModelFactory(UserSession session){
		this.session = session ;
	}
	
	public QueryObjectModel createQuery(Source source, Constraint constraint, Ordering[] orderings, Column[] columns) throws InvalidQueryException {
		return new QueryObjectModel(session, source, constraint, orderings, columns);
	}

	public Selector selector(String selectorId, NodeType nodetype) throws InvalidQueryException, RepositoryException {
		return new Selector(selectorId, nodetype);
	}

	public Join join(Source left, Source right, String joinType, JoinCondition joinCondition) throws InvalidQueryException, RepositoryException {
		return null;
	}

	public EquiJoinCondition equiJoinCondition(String selector1Name, String property1Name, String selector2Name, String property2Name) throws InvalidQueryException, RepositoryException {
		return null;
	}

}
