package com.bleujin.lore.extend.template;

import java.io.Serializable;

import com.bleujin.framework.db.procedure.IStringObject;
import com.bleujin.framework.util.StringUtil;

public class TemplateId implements IStringObject, Serializable{
 
	private static final long serialVersionUID = 2310529594774636932L;

	private final static int MAX_LENGTH = 40;
	
	private String tplId ;
	public TemplateId(String tplId) {
		this.tplId = tplId ;
	}

	public final static TemplateId createId(String id){
		if (id == null) throw new IllegalArgumentException("id is null, smallAlphaNumUnderBarSlash, maxLength:" + MAX_LENGTH) ;

		String lowerId = id.toLowerCase() ;
		if (StringUtil.isSmallAlphaNumUnderBarSlash(lowerId) && id.length() <= MAX_LENGTH) {
			return new TemplateId(lowerId) ;
		}
		throw new IllegalArgumentException(id + " smallAlphaNumUnderBarSlash, maxLength:" + MAX_LENGTH) ;
	}
	
	public boolean equals(Object obj){
		if (!(obj instanceof TemplateId )) return false ;
		return this.tplId.equals(((TemplateId)obj).tplId) ;
	}
	
	public int hashCode(){
		return tplId.hashCode() ;
	}
	
	public String getString() {
		return tplId;
	}

}
