package com.bleujin.lore.extend.template;

import org.apache.velocity.app.Velocity;
import org.apache.velocity.runtime.RuntimeServices;
import org.apache.velocity.runtime.log.LogChute;

import com.bleujin.lore.common.Debug;

public class TemplateLogger implements LogChute {

	public TemplateLogger() {
		try {
			// register this class as a logger with the Velocity singleton (NOTE: this would not work for the non-singleton method.)
			Velocity.setProperty(Velocity.RUNTIME_LOG_LOGSYSTEM, this);
			Velocity.init();
		} catch (Exception e) {
			e.printStackTrace() ;
		}
	}

	public void init(RuntimeServices service) throws Exception {
		// do nothing
		// Debug.debug(this, "init") ;
	}

	public boolean isLevelEnabled(int level) {
		return false;
	}

	public void log(int level, String message) {
		Debug.debug(this, message) ;
		// do nothing
	}

	public void log(int level, String message, Throwable exception) {
		Debug.debug(this, message) ;
	}

}
