package com.bleujin.lore.extend.template;

import com.bleujin.lore.core.common.GenericIterator;
import com.bleujin.lore.core.dimpl.UserSession;
import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.nodetype.NodeType;
import com.bleujin.lore.core.persitence.GlobalStore;

public class TemplateManagerImpl implements TemplateManager {

	private UserSession session ;
	private GlobalStore gs ;
	private TemplateManagerImpl(UserSession session, GlobalStore gs) {
		this.session = session ;
		this.gs = gs ;
	}
	
	public static TemplateManager create(UserSession session, GlobalStore gs){
		return new TemplateManagerImpl(session, gs) ;
	}
	
	private GlobalStore getGlobalStore(){
		return gs ;
	}
	
	public Template saveTemplate(TemplateId id, TemplateImpl template) throws ALRepositoryException {
		return getGlobalStore().saveTemplate(id, template);
	}
	public void bindTemplate(NodeType nodeType, TemplateId tplId) throws ALRepositoryException {
		getGlobalStore().bindTemplate(nodeType, tplId) ;
	}

	public void bindTemplate(Node node, TemplateId tplId) throws ALRepositoryException {
		getGlobalStore().bindTemplate(node, tplId) ;
	}
	public Template getBoundTemplate(String nodeInfo) throws ALRepositoryException{
		return getGlobalStore().getBoundTemplate(session.getNode(nodeInfo)) ;
	}
	
	public Template getTemplate(String tplId) throws ALRepositoryException {
		return getGlobalStore().getTemplate(session, TemplateId.createId(tplId)) ;
	}

	public GenericIterator<TemplateId> getTemplates() throws ALRepositoryException {
		return getGlobalStore().getTemplates(session) ;
	}	
}
