package com.bleujin.lore.extend.template;

import com.bleujin.lore.core.TestCaseParent;
import com.bleujin.lore.core.node.Node;

public class TestTemplate extends TestCaseParent{

	private TemplateManager templateManager ;
	public void setUp() throws Exception {
		super.setUp() ;
		this.templateManager = session.getTemplateManager() ;
	}
	public void testCreate() throws Exception {
		Template template = TemplateImpl.create(session, "/abcd", "$session.getRootNode().getName() Hello") ;
		
		Template load = templateManager.getTemplate("/abcd") ;
		String result = template.applyTemplate() ;
		assertEquals(result, "/ Hello") ;
		
		
	}

	public void testApplyTemplate() throws Exception {
		Node node = saveNode(objectType, "newbie") ;
		session.save() ;
		Template template = TemplateImpl.create(session, "/abcd", "$session.getNode('/newbie').getName() Hello") ;
		
		Template load = templateManager.getTemplate("/abcd") ;
		String result = load.applyTemplate() ;
		assertEquals("newbie Hello", result) ;
	}

	public void testMappingDefault() throws Exception {
		Node node = saveNode(objectType, "newbie") ;
		session.save() ;
		
		Template template = templateManager.getBoundTemplate("/newbie") ;
		assertEquals("newbie", template.applyTemplate()) ;
	}

	public void testMappingNode() throws Exception {
		Node newbie = saveNode(objectType, "newbie") ;
		session.save() ;
		Template template = TemplateImpl.create(session, "/abcd", "$session.getNode('/newbie').name Hello") ;
		template.bind(newbie) ;
		
		Template load = templateManager.getBoundTemplate("/newbie") ;
		assertEquals("newbie Hello", load.applyTemplate()) ;
	}

	public void testMappingNodeType() throws Exception {
		Node newbie = saveNode(objectType, "newbie") ;
		session.save() ;
		Template template = TemplateImpl.create(session, "/abcd", "$session.getNode('/newbie').name Hello") ;
		template.bind(newbie.getNodeType()) ;
		
		Template load = templateManager.getBoundTemplate("/newbie") ;
		assertEquals("newbie Hello", load.applyTemplate()) ;
	}
	
}
