package com.bleujin.lore.impl.sample;

import com.bleujin.lore.core.dimpl.UserSession;
import com.bleujin.lore.core.exception.ALRepositoryException;
import com.bleujin.lore.core.node.Node;
import com.bleujin.lore.core.nodetype.NodeType;
import com.bleujin.lore.extend.template.Template;
import com.bleujin.lore.extend.template.TemplateImpl;

public class NoticeSampleTemplate {

	private UserSession session;

	NoticeSampleTemplate(UserSession session) {
		this.session = session;
	}

	public void imp(NodeType rootType, Node rootNode) throws ALRepositoryException {
		createTemplate(rootType, rootNode);
	}

	private void createTemplate(NodeType rootType, Node rootNode) throws ALRepositoryException {
		Template template = TemplateImpl.create(session, "/sample/default", "$node");
		template.bind(rootType);
		
		String content = "" +
		"#foreach( $child in $node.getChildNode()) \n" +  
	    "	<li>$child : $child.Name : <a href='../viewer.do?UUID=$child.getIdentifier()'>$child.getIdentifier()</a> </li> \n" +
		"#end" ;
		
		
		Template noticeTemplate = TemplateImpl.create(session, "/sample/child", content) ;
		NodeType noticeType = session.getNodeTypeManager().getNodeType("sample:notice");
		noticeTemplate.bind(noticeType) ;

	}
}
