package com.bleujin.lore.install;

import java.sql.SQLException;

import com.bleujin.framework.configuration.Configuration;
import com.bleujin.framework.configuration.ConfigurationFactory;
import com.bleujin.framework.db.DBController;
import com.bleujin.framework.db.DBControllerInstantiationException;
import com.bleujin.framework.db.Rows;

public class ConfirmDBConfig implements ISetupTask {

	private Configuration config;
	private InstallOuter outer;

	public ConfirmDBConfig(Configuration config, InstallOuter outer) {
		this.config = config;
		this.outer = outer;
	}

	public boolean execute() throws TaskException {
		ConfigurationFactory cf = null;
		DBController dc = null;
		try {
			dc = new DBController(config);
			dc.init();
		} catch (DBControllerInstantiationException e) {
			throw new TaskException(e.getMessage() + "\nINACCURACY DB-Setting-Info. confirm [root.database-controller] in 'default-config.xml' file.", e);
		} catch (SQLException e) {
			throw new TaskException(e.getMessage() + "\nINACCURACY DB-Connection-Info. confirm [root.database-controller] in 'default-config.xml' file.", e);
		} finally {
			if (dc != null) dc._destroy() ;
		}
		outer.info("Green : DB Status.");
		// dc.getDBManager().initPoolConnection() ;

		Rows rows = dc.getRows("select * from dual ");
		outer.info("Green : Query Execute");
		return true;
	}

}
