package com.bleujin.lore.install;

import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;

import com.bleujin.framework.db.DBController;
import com.bleujin.framework.db.NRows;
import com.bleujin.framework.db.procedure.IUserProcedure;

public class RowToWrite {

	private NRows rows ;
	private Writer writer ;
	private String colName ;
	
	public RowToWrite(NRows rows, Writer writer, String colName){
		this.rows = rows ;
		this.writer = writer ;
		this.colName = colName ;
	}
	
	public void writeRow() throws IOException {
		while(rows.next()){
			writer.write(rows.getString(colName)) ;
		}
		writer.flush() ;
		writer.close() ;
	}
	
	public static void main(String[] args) throws Exception{
		
		if (args == null || args.length == 0){
			args = new String[]{"D:/eclipse/workspace/anotherLore/etc"} ;
		}
		
		DBController dc = DBController.getTestInstance() ;
		dc.init() ;
		
		IUserProcedure upt = dc.createUserProcedure("OnlyAdmin@tableSource()");
		NRows rows = new NRows(dc.execQuery(upt));

		String fileName = args[0] + "/table.sql" ;
		FileWriter writer = new FileWriter(fileName) ; 

		RowToWrite towrite = new RowToWrite(rows, writer, "text") ;
		towrite.writeRow() ;
		rows.close() ;


		upt = dc.createUserProcedure("OnlyAdmin@indexSource()");
		rows = new NRows(dc.execQuery(upt));

		fileName = args[0] + "/index.sql" ;
		writer = new FileWriter(fileName) ; 

		towrite = new RowToWrite(rows, writer, "text") ;
		towrite.writeRow() ;
		rows.close() ;

		
		upt = dc.createUserProcedure("OnlyAdmin@packageSource()");
		rows = new NRows(dc.execQuery(upt));

		fileName = args[0] + "/package.sql" ;
		writer = new FileWriter(fileName) ; 

		towrite = new RowToWrite(rows, writer, "text") ;
		towrite.writeRow() ;
		rows.close() ;
		
		
		dc._destroy() ;
	}
}
