package com.bleujin.lore.install;

import java.util.List;

public class SetUp implements ISetupTask {

	private List<ISetupTask> tasks ;
	private InstallOuter outer ;
	public SetUp(List<ISetupTask> tasks, InstallOuter outer){
		this.tasks = tasks ;
		this.outer = outer ; 
	}
	
	public boolean execute() throws TaskException {

		boolean result = Boolean.TRUE ;
		try {
			for(ISetupTask task : tasks){
				result = result && task.execute() ;
			}

			if (result) {
				outer.info("SETUP COMPLETED") ;
			} else {
				outer.warning("SETUP FAILED") ;
			}
			
			return result ;
		} catch (Exception ex) {
			throw new TaskException(ex);
		}
	}

}
