package com.bleujin.lore.install;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import junit.framework.TestCase;

import com.bleujin.framework.configuration.Configuration;
import com.bleujin.framework.configuration.ConfigurationFactory;
import com.bleujin.framework.configuration.DefaultConfigurationFactory;
import com.bleujin.framework.db.DBController;
import com.bleujin.framework.db.servant.NoneServant;
import com.bleujin.lore.core.workspace.config.LicenseInfo;
import com.bleujin.lore.install.fetch.RecreateEntity;

public class TestSetupTask extends TestCase {

	private String configFileName = "D:/eclipse/workspace/anotherLore/webapps/board/WEB-INF/default-config.xml";
	private InstallOuter outer;

	public void setUp() throws Exception {
		outer = new InstallOuter();
	}

	public void testSetup() throws Exception {

		String configFileName = "webapps/board/WEB-INF/default-config.xml";

		ConfigurationFactory cf = DefaultConfigurationFactory.getInstance("al-install-test");
		cf.build(configFileName);
		Configuration configRoot = cf.getConfiguration("root");

		//
		List<ISetupTask> tasks = new ArrayList<ISetupTask>();
		LicenseInfo bi = new LicenseInfo(configRoot.getChild("license"));
		tasks.add(new ConfirmProgram(bi, outer));
		tasks.add(new ConfirmDBConfig(configRoot.getChild("database-controller"), outer));

		DBController dc = new DBController(configRoot.getChild("database-controller"));
		dc.init();
		dc.changeServant(new NoneServant());

		tasks.add(new RecreateEntity(dc, outer, "webapps/board/etc/database/oracle/"));
		boolean result = new SetUp(tasks, outer).execute();

		dc._destroy();
		assertEquals(true, result);
	}

	public void xtestStartup() throws Exception {

		DBController dc = DBController.getTestInstance();
		dc.init();

		RecreateEntity dsf = new RecreateEntity(dc, outer, "D:/eclipse/workspace/anotherLore/etc/");
		dsf.execute();

		dc._destroy();
	}

	public void xtestDBSetup() throws Exception {

		ConfigurationFactory cf = DefaultConfigurationFactory.getInstance("al-install-test");
		cf.build(new File(configFileName));
		Configuration config = cf.getConfiguration("root");

		ISetupTask task = new ConfirmDBConfig(config.getChild("database-controller"), outer);
		task.execute();

		task = new ConfirmProgram(new LicenseInfo(config.getChild("license")), outer);
		task.execute();
	}
}
