package com.bleujin.lore.install.fetch;

import java.io.File;
import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.commons.io.FileUtils;
import org.apache.commons.lang.SystemUtils;

import com.bleujin.framework.db.DBController;
import com.bleujin.framework.util.StringUtil;
import com.bleujin.lore.install.ISetupTask;
import com.bleujin.lore.install.InstallOuter;

public class CreateSequence implements ISetupTask {

	private DBController dc;
	private InstallOuter outer;
	private String fileName;

	public CreateSequence(DBController dc, InstallOuter outer, String fileName) {
		this.dc = dc;
		this.outer = outer ; 
		this.fileName = fileName;
	}

	public boolean execute() {
		try {
			String read = FileUtils.readFileToString(new File(fileName), SystemUtils.FILE_ENCODING);

			String innerReg = "\\ncreate sequence\\W([0-9a-zA-Z_#]*)";
			Pattern pattern = Pattern.compile(innerReg, Pattern.CASE_INSENSITIVE);

			String[] sequences = read.split(";");

			outer.info("SEQUENCE =====================");
			for (String sequence : sequences) {
				if (StringUtil.isBlank(sequence))
					continue;
				dc.execUpdate(sequence);
				// Debug.debug(this, sequence) ;

				Matcher matcher = pattern.matcher(sequence);
				if (matcher.find()) {
					outer.log(matcher.group(1) + " CREATED");
				}

			}
		} catch (IOException e) {
			outer.warning(e.getMessage()) ;
			return false ;
		} 
		return true ;
	}

}
