package com.bleujin.lore.install.fetch;

import java.io.File;
import java.io.IOException;

import org.apache.commons.io.FileUtils;
import org.apache.commons.lang.SystemUtils;

import com.bleujin.framework.db.DBController;
import com.bleujin.framework.util.StringUtil;
import com.bleujin.lore.install.ISetupTask;
import com.bleujin.lore.install.InstallOuter;

public class DropEntity implements ISetupTask
{
	private DBController dc ;
	private String fileName ;
	private InstallOuter outer;
	public DropEntity(DBController dc, InstallOuter outer, String fileName){
		this.dc = dc ;
		this.outer = outer ;
		this.fileName = fileName ;
	}

	public boolean execute() {
		try {
			String read = FileUtils.readFileToString(new File(fileName), SystemUtils.FILE_ENCODING);

			String[] drops = read.split(";");

			outer.info("DROP =====================");
			for (String drop : drops) {
				if (StringUtil.isBlank(drop))
					continue;
				dc.execUpdate(drop);

				outer.log(drop.trim());
			}
		} catch (IOException e) {
			outer.warning(e.getMessage()) ;
			return false ;
		} 
		return true ;
	}

}
