package com.bleujin.lore.install.fetch;

import com.bleujin.framework.db.DBController;
import com.bleujin.framework.util.PathMaker;
import com.bleujin.lore.install.ISetupTask;
import com.bleujin.lore.install.InstallOuter;

public class RecreateEntity implements ISetupTask {

	private DBController dc;
	private InstallOuter outer ;
	private String dirName;

	public RecreateEntity(DBController dc, InstallOuter outer, String dirName) {
		this.dc = dc;
		this.outer = outer ;
		this.dirName = dirName;
	}

	public boolean execute() {

		try {
			DropEntity drop = new DropEntity(dc, outer, PathMaker.getFilePath(dirName, "drop.sql"));
			drop.execute();
			
		} catch (Throwable ignore) {
			outer.warning(ignore.getMessage()) ;
		}

		try {
			CreateTable tab = new CreateTable(dc, outer, PathMaker.getFilePath(dirName, "table.sql"));
			tab.execute();
		} catch (Throwable ignore) {
			outer.warning(ignore.getMessage()) ;
		}

		try {
			CreateIndex ind = new CreateIndex(dc, outer, PathMaker.getFilePath(dirName,  "index.sql"));
			ind.execute();
		} catch (Throwable ignore) {
			outer.warning(ignore.getMessage()) ;
		}

		try {
			CreateSequence seq = new CreateSequence(dc, outer, PathMaker.getFilePath(dirName,  "/sequence.sql"));
			seq.execute();
		} catch (Throwable ignore) {
			outer.warning(ignore.getMessage()) ;
		}

		try {
			CreatePackage pack = new CreatePackage(dc, outer, PathMaker.getFilePath(dirName,  "/package.sql"));
			pack.execute();
		} catch (Throwable ignore) {
			outer.warning(ignore.getMessage()) ;
		}

		return true;
	}

}
